

#    MIDAS Access Client  for the  VMEAccess service

package require MIDASAccessClient    ;#   load default support procedures

global MIDAS_VMEAccessClient_Exists
set MIDAS_VMEAccessClient_Exists 1

global VMEAccessServerHost VMEAccessServerPort

if {[info exists VMEAccessServerHost] == 0} then {set VMEAccessServerHost localhost}
if {[info exists VMEAccessServerPort] == 0} then {set VMEAccessServerPort 8015}

variable uri "urn:VMEAccessServer"
variable proxy "http://$VMEAccessServerHost:$VMEAccessServerPort/VMEAccessServer"

set VMEAccessServerTimeOut 10000

proc VMEAccessClient_Configure {} {
   global  VMEAccessServerHost VMEAccessServerPort
   variable proxy

   set proxy "http://$VMEAccessServerHost:$VMEAccessServerPort/VMEAccessServer"

   foreach method [info procs VMEAccessClient__*] {catch {SOAP::configure $method -proxy $proxy}}
}

SOAP::create VMEAccessClient__DefineRegister -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name DefineRegister \
     -params {Register string Class string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__InquireRegisters -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name InquireRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create VMEAccessClient__ReadRegisterAttributes -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name ReadRegisterAttributes \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__ReadRegistersAttributes -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name ReadRegistersAttributes \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__DeleteRegister -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name DeleteRegister \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__DeleteRegisters -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name DeleteRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__WriteRegisterAttributes -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name WriteRegisterAttributes \
     -params {Register string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__WriteRegistersAttributes -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name WriteRegistersAttributes \
     -params {Pattern string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__WriteRegister -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name WriteRegister \
     -params {Register string Value int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__WriteRegisters -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name WriteRegisters \
     -params {Pattern string Value int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__InitialiseRegister -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name InitialiseRegister \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__InitialiseRegisters -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name InitialiseRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__ReadRegister -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name ReadRegister \
     -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__ReadRegisters -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name ReadRegisters \
     -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__BusWrite -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name BusWrite \
     -params {Address int AddressModifer string DataWidth string Value int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create VMEAccessClient__BusRead -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name BusRead \
     -params {Address int AddressModifier string DataWidth string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__InterfaceStatus -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name InterfaceStatus \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create VMEAccessClient__AccessServerVerbose -proxy $proxy -uri $uri -timeout $VMEAccessServerTimeOut \
     -name AccessServerVerbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 



package provide VMEAccessClient 1.0

puts "VMEAccessClient provided"
