

puts "loading sys.V1751PSD.tcl"

variable registerlist

lappend registerlist [list NetVar.V1751PSD_NumSamples  "-n V1751PSD_NumSamples -t int"]
lappend registerlist [list NetVar.V1751PSD_VMERetries  "-n V1751PSD_VMERetries -t int"]
lappend registerlist [list NetVar.V1751PSD_BERREnable  "-n V1751PSD_BERREnable -t int"]
lappend registerlist [list NetVar.V1751PSD_VMEBufSize  "-n V1751PSD_VMEBufSize -t int"]

variable NumChans 8
variable V1751PSD_Base 192

proc Set_V1751PSD_Options {} {
    variable Options
    variable V1751PSD_Base

puts "Set_V1751PSD_Options"

    load_Options

   if {![info exists Options(V1751PSD_MaxEvtsPerBuf)]}         {set Options(V1751PSD_MaxEvtsPerBuf) 1}
   if {![info exists Options(V1751PSD_MaxBLT)]}                {set Options(V1751PSD_MaxBLT) 1}
   if {![info exists Options(V1751PSD_MemBufSize)]}            {set Options(V1751PSD_MemBufSize) 1024}
   if {![info exists Options(V1751PSD_VMEBufSize)]}            {set Options(V1751PSD_VMEBufSize) 16384}

   if {![info exists Options(V1751PSD_Hist_TraceA.Enable)]}    {set Options(V1751PSD_Hist_TraceA.Enable) 0}
   if {![info exists Options(V1751PSD_Hist_TraceB.Enable)]}    {set Options(V1751PSD_Hist_TraceB.Enable) 0}
   if {![info exists Options(V1751PSD_Hist_DVP0.Enable)]}      {set Options(V1751PSD_Hist_DVP0.Enable) 0}
   if {![info exists Options(V1751PSD_Hist_DVP1.Enable)]}      {set Options(V1751PSD_Hist_DVP1.Enable) 0}
   if {![info exists Options(V1751PSD_Hist_BaseLine.Enable)]}  {set Options(V1751PSD_Hist_BaseLine.Enable) 0}
   if {![info exists Options(V1751PSD_Hist_QLong.Enable)]}     {set Options(V1751PSD_Hist_QLong.Enable) 1}
   if {![info exists Options(V1751PSD_Hist_QShort.Enable)]}    {set Options(V1751PSD_Hist_QShort.Enable) 1}
   if {![info exists Options(V1751PSD_Hist_TimeX.Enable)]}     {set Options(V1751PSD_Hist_TimeX.Enable) 0}
   if {![info exists Options(V1751PSD_Hist_TimeH.Enable)]}     {set Options(V1751PSD_Hist_TimeH.Enable) 0}
   if {![info exists Options(V1751PSD_Hist_TimeL.Enable)]}     {set Options(V1751PSD_Hist_TimeL.Enable) 0}
   if {![info exists Options(V1751PSD_Hist_Wave.Enable)]}      {set Options(V1751PSD_Hist_Wave.Enable) 0}
   if {![info exists Options(V1751PSD_Hist_Wave.channels)]}    {set Options(V1751PSD_Hist_Wave.channels) 512}
   if {![info exists Options(V1751PSD_Hist_Wave.offset)]}      {set Options(V1751PSD_Hist_Wave.offset) 0}
   if {![info exists Options(V1751PSD_Hist_Wave.shift)]}       {set Options(V1751PSD_Hist_Wave.shift) 0}
   if {![info exists Options(V1751PSD_Hist_BaseLine.channels)]}  {set Options(V1751PSD_Hist_BaseLine.channels) 65536}
   if {![info exists Options(V1751PSD_Hist_BaseLine.offset)]}    {set Options(V1751PSD_Hist_BaseLine.offset) 0}
   if {![info exists Options(V1751PSD_Hist_BaseLine.shift)]}     {set Options(V1751PSD_Hist_BaseLine.shift) 0}
   if {![info exists Options(V1751PSD_Hist_TimeX.channels)]}   {set Options(V1751PSD_Hist_TimeX.channels) 65536}
   if {![info exists Options(V1751PSD_Hist_TimeX.offset)]}     {set Options(V1751PSD_Hist_TimeX.offset) 0}
   if {![info exists Options(V1751PSD_Hist_TimeX.shift)]}      {set Options(V1751PSD_Hist_TimeX.shift) 0}
   if {![info exists Options(V1751PSD_Hist_TimeH.channels)]}   {set Options(V1751PSD_Hist_TimeH.channels) 65536}
   if {![info exists Options(V1751PSD_Hist_TimeH.offset)]}     {set Options(V1751PSD_Hist_TimeH.offset) 0}
   if {![info exists Options(V1751PSD_Hist_TimeH.shift)]}      {set Options(V1751PSD_Hist_TimeH.shift) 0}
   if {![info exists Options(V1751PSD_Hist_TimeL.channels)]}   {set Options(V1751PSD_Hist_TimeL.channels) 65536}
   if {![info exists Options(V1751PSD_Hist_TimeL.offset)]}     {set Options(V1751PSD_Hist_TimeL.offset) 0}
   if {![info exists Options(V1751PSD_Hist_TimeL.shift)]}      {set Options(V1751PSD_Hist_TimeL.shift) 0}
   if {![info exists Options(V1751PSD_Hist_QLong.channels)]}   {set Options(V1751PSD_Hist_QLong.channels) 65536}
   if {![info exists Options(V1751PSD_Hist_QLong.offset)]}     {set Options(V1751PSD_Hist_QLong.offset) 0}
   if {![info exists Options(V1751PSD_Hist_QLong.shift)]}      {set Options(V1751PSD_Hist_QLong.shift) 0}
   if {![info exists Options(V1751PSD_Hist_QShort.channels)]}   {set Options(V1751PSD_Hist_QShort.channels) 65536}
   if {![info exists Options(V1751PSD_Hist_QShort.offset)]}     {set Options(V1751PSD_Hist_QShort.offset) 0}
   if {![info exists Options(V1751PSD_Hist_QShort.shift)]}      {set Options(V1751PSD_Hist_QShort.shift) 0}
   if {![info exists Options(V1751PSD_GroupBase)]}             {set Options(V1751PSD_GroupBase) $V1751PSD_Base}
   set V1751PSD_Base  $Options(V1751PSD_GroupBase)

    update_Options
}

proc V1751PSD_Configure {} {
    variable Options
    variable NumChans
    variable V1751PSD_Base

puts "V1751PSD_Configure"

      set z [catch {ReadVMERegister v1751psd#1.BoardInfo} m]
      if {$z==0} then {set NumChans [expr ($m >> 16) & 255]}

puts "V1751PSD_Configure: channels=$NumChans; GroupBase=$V1751PSD_Base"

    set VME_BUFFER_SIZE [ReadNetVar NetVar.V1751PSD_VMEBufSize]
    set Options(V1751PSD_VMEBufSize) $VME_BUFFER_SIZE

           switch $Options(V1751PSD_MemBufSize) {
              65536 {set BUFF_ORG 2; set BUFF_NUM 4}
              32768 {set BUFF_ORG 3; set BUFF_NUM 8}
              16384 {set BUFF_ORG 4; set BUFF_NUM 16}
              8192  {set BUFF_ORG 5; set BUFF_NUM 32}
              4096  {set BUFF_ORG 6; set BUFF_NUM 64}
              2048  {set BUFF_ORG 7; set BUFF_NUM 128}
              1024  {set BUFF_ORG 8; set BUFF_NUM 256}
              512   {set BUFF_ORG 9; set BUFF_NUM 512}
              256   {set BUFF_ORG 10; set BUFF_NUM 1024}
              default {set BUFF_ORG 8; set BUFF_NUM 256; set Options(V1751PSD_MemBufSize) 1024}
           }

      update_Options

      set BUFF_SIZE $Options(V1751PSD_MemBufSize)       ;# buffer size in 32 bit words

      set z [catch {ReadVMERegisterAttr v1751psd#1.VMEStatus} m]
      if {$z==0} then {

           WriteVMERegister v1751psd#1.VMEControl 16   ;# force BERR option

           set z [catch {ReadVMERegister v1751psd#1.CustomSize} SIZE]
           WriteNetVar NetVar.V1751PSD_NumSamples [expr $SIZE * 12]

           set WORDS [expr ((((($SIZE * 12) / 3) + 3) + 2) * $NumChans)]   ;# convert to 32 bit words

           set NUM [expr $BUFF_SIZE / (4+$WORDS)]  ;# events per buffer
           if {$NUM > $Options(V1751PSD_MaxEvtsPerBuf)} {set NUM $Options(V1751PSD_MaxEvtsPerBuf)}

           set z [catch {ReadVMERegister v1751psd#1.VMEControl} BERR]  ;#  enable BERR to finish a VME block transfer
           if {$BERR < 0} {set BERR 0}
           WriteNetVar NetVar.V1751PSD_BERREnable [expr ($BERR >> 4) & 1]

puts "V1751PSD Output buffers $BUFF_NUM  @ $BUFF_SIZE 32 bit words per channel"
puts "Waveform [expr $SIZE * 12] samples"
puts "$NumChans channels; $NUM events/buffer"

           set osize [expr ($WORDS + 4) * $NUM]
puts "V1751PSD buffer size used $osize words out of max $Options(V1751PSD_MemBufSize)"

           if {$osize > $Options(V1751PSD_MemBufSize)} {
              puts "Number of samples or Events per buffer is too big\n\
                 $osize > $Options(V1751PSD_MemBufSize) - this is not permitted\n\
                 correct options and try again"
              return
           }

           set BLT [expr $VME_BUFFER_SIZE / $osize]
           if {$BLT > $Options(V1751PSD_MaxBLT)} {set BLT $Options(V1751PSD_MaxBLT)}

puts "BLT Event Number = $BLT"
           set isize [expr $osize * $BLT]
puts "Data Acq Input buffer size used $isize words out of max $VME_BUFFER_SIZE"

puts "V1751PSD_Configure $BERR $SIZE $BUFF_ORG $NUM $BLT"

           WriteVMERegisters v1751psd#*.VMEControl $BERR     ;# set all modules to same setting
           WriteVMERegisters v1751psd#*.CustomSize $SIZE     ;# set all modules to same setting
           WriteVMERegisters v1751psd#*.BufferOrg $BUFF_ORG
           WriteVMERegisters v1751psd#*.EvtsPerBuf $NUM
           WriteVMERegisters v1751psd#*.BLTEventNum $BLT     ;# set all modules to same setting
      }

puts "V1751PSD_Configure finished"

}

proc V1751PSD_DAQ-go {} {puts "V1751PSD_DAQ-go"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1751psd#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegister v1751psd#$i.AcqControl} m]
      if {$z == 0} {WriteVMERegister v1751psd#$i.AcqControl [expr ($m & 0xfb) + 4]}

   }
}

proc V1751PSD_DAQ-halt {} {puts "V1751PSD_DAQ-halt"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1751psd#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegister v1751psd#$i.AcqControl} m]
      if {$z == 0} {WriteVMERegister v1751psd#$i.AcqControl [expr ($m & 0xfb)]}

   }

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {WriteVMERegister v1751psd#$i.Clear 0} m]

   }
}

proc V1751PSD_DAQ-setup {} {puts "V1751PSD_DAQ-setup"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1751psd#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }
   if {$maxmodule == 0} {return}

   V1751PSD_Configure
}

proc V1751PSD_DAQ-flush {} {}

proc V1751PSD_DAQ-reset {} {}

proc Dump_Raw_VME_Data_V1751PSD {data} {

        foreach word $data {
           if {[string range $word 0 1] != "0x"} then {set word 0x$word}
           if {$word == 0xaa5555aa} then {
               append info "$word - end of dump\n"
               break
           }
           if {$word == 0x55aaaa55} then {
               append info "$word - end of event\n"
               continue
           }
           append info "$word "
        }

        append info "\n"

   return $info
}

proc define_V1751PSD_config {} {puts "define_V1751PSD_config"
    variable Options
    variable V1751PSD_Base

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1751psd#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   if {$maxmodule > 0} then {DefineConfig "17512 0 [format "0x%x" $V1751PSD_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {ReadVMERegisterAttr v1751psd#$i.Output_Buffer} m]
      if {$z!=0} then {
          puts "Attempting to locate register v1751psd#$i.Output_Buffer"
          error $m
      }

      DefineConfig "17512 $i [string range [first $m] 2 end]"
   }
}

proc create_V1751PSD_spectra {} {
    variable V1751PSD_Base
    variable Options 
    variable NumChans

puts "create_V1751PSD_spectra"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr v1751psd#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   set UseGroup [ReadNetVar NetVar.UseGroup]

   for {set i 1} {$i <= $maxmodule} {incr i} {

     if {$Options(V1751PSD_Hist_QLong.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the computed charge

           set spectrumname v1751psd#$i.QL[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751PSD_Hist_QLong.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {

               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1751PSD_Base]
                   set item [expr $j + (0 << 3)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $V1751PSD_Base]
                   set item 0
               }
               map_spectrum  "$spectrumname $group $item $Options(V1751PSD_Hist_QLong.offset) $Options(V1751PSD_Hist_QLong.shift)"

           }
        }
     }

     if {$Options(V1751PSD_Hist_QShort.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the computer charge

           set spectrumname v1751psd#$i.QS[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751PSD_Hist_QShort.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {

               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1751PSD_Base]
                   set item [expr $j + (1 << 3)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $V1751PSD_Base]
                   set item 1
               }
               map_spectrum  "$spectrumname $group $item $Options(V1751PSD_Hist_QShort.offset) $Options(V1751PSD_Hist_QShort.shift)"

           }
        }
     }

     if {$Options(V1751PSD_Hist_TimeX.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the time (Extended)

           set spectrumname v1751psd#$i.TX[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751PSD_Hist_TimeX.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1751PSD_Base]
                   set item [expr $j + (4 << 3)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $V1751PSD_Base]
                   set item 4
               }
              map_spectrum  "$spectrumname $group $item $Options(V1751PSD_Hist_TimeH.offset) $Options(V1751PSD_Hist_TimeH.shift)"
           }
        }
     }

     if {$Options(V1751PSD_Hist_TimeH.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the time (MSW)

           set spectrumname v1751psd#$i.TH[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751PSD_Hist_TimeH.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1751PSD_Base]
                   set item [expr $j + (2 << 3)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $V1751PSD_Base]
                   set item 2
               }
              map_spectrum  "$spectrumname $group $item $Options(V1751PSD_Hist_TimeH.offset) $Options(V1751PSD_Hist_TimeH.shift)"
           }
        }
     }

    if {$Options(V1751PSD_Hist_TimeL.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the time (LSW)

           set spectrumname v1751psd#$i.TL[set j]
           set-footer "Creating $spectrumname"
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751PSD_Hist_TimeL.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1751PSD_Base]
                   set item [expr $j + (3 << 3)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $V1751PSD_Base]
                   set item 3
               }
              map_spectrum  "$spectrumname $group $item $Options(V1751PSD_Hist_TimeL.offset) $Options(V1751PSD_Hist_TimeL.shift)"
           }
        }
     }

     if {$Options(V1751PSD_Hist_BaseLine.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the base line

           set spectrumname v1751psd#$i.B[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751PSD_Hist_BaseLine.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {

               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1751PSD_Base]
                   set item [expr $j + (5 << 3)]
               } else {
                   set group [expr (($i - 1) * $NumChans) + $j + $V1751PSD_Base]
                   set item 5
               }
               map_spectrum  "$spectrumname $group $item $Options(V1751PSD_Hist_BaseLine.offset) $Options(V1751PSD_Hist_BaseLine.shift)"

           }
        }
     }

     if {$Options(V1751PSD_Hist_Wave.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the waveform

           set spectrumname v1751psd#$i.W[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751PSD_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
              set group  [expr (($i-1) * $NumChans) + $j  + $V1751PSD_Base + 256] 
              set item 0
              map_spectrum  "$spectrumname $group $item $Options(V1751PSD_Hist_Wave.offset) $Options(V1751PSD_Hist_Wave.shift)"
           }
        }
     }

     if {$Options(V1751PSD_Hist_TraceA.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the data trace A

           set spectrumname v1751psd#$i.ChA[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751PSD_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
              set group  [expr (($i-1) * $NumChans) + $j  + $V1751PSD_Base + 384] 
              set item 0
              map_spectrum  "$spectrumname $group $item $Options(V1751PSD_Hist_Wave.offset) $Options(V1751PSD_Hist_Wave.shift)"
           }
        }
     }

     if {$Options(V1751PSD_Hist_TraceB.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the data trace B

           set spectrumname v1751psd#$i.ChB[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751PSD_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
              set group  [expr (($i-1) * $NumChans) + $j  + $V1751PSD_Base + 384] 
              set item 1
              map_spectrum  "$spectrumname $group $item $Options(V1751PSD_Hist_Wave.offset) $Options(V1751PSD_Hist_Wave.shift)"
           }
        }
     }

     if {$Options(V1751PSD_Hist_DVP0.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the  digital virtual probe 0

           set spectrumname v1751psd#$i.DVP0[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751PSD_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
              set group  [expr (($i-1) * $NumChans) + $j  + $V1751PSD_Base + 384] 
              set item 2
              map_spectrum  "$spectrumname $group $item $Options(V1751PSD_Hist_Wave.offset) $Options(V1751PSD_Hist_Wave.shift)"
           }
        }
     }

     if {$Options(V1751PSD_Hist_DVP1.Enable) == 1} {

        for {set j 0} {$j < $NumChans} {incr j} {   

#    histograms for the  digital virtual probe 1

           set spectrumname v1751psd#$i.DVP1[set j]
           set z [catch {CreateSpectrum1D $spectrumname $Options(V1751PSD_Hist_Wave.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              puts "Attempting to create spectrum $spectrumname"
              error $m
           } else {
              set group  [expr (($i-1) * $NumChans) + $j  + $V1751PSD_Base + 384] 
              set item 3
              map_spectrum  "$spectrumname $group $item $Options(V1751PSD_Hist_Wave.offset) $Options(V1751PSD_Hist_Wave.shift)"
           }
        }
     }

   }
}

