

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable online 0
    variable rtp 0
    variable alladcs 0
    variable allmodules 0

    for {set i 0} {$i < 32} {incr i} {variable Threshold$i $i}

    variable Rmsg
    variable Wmsg

    variable ModuleName s9418
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

#    register access procedures

   proc ReadRegister {RegName} {
       global errorCode errorInfo
       variable ModuleName
       variable ModuleIndex
       variable Rmsg

       set r $ModuleName#$ModuleIndex
       set z [catch {::namespace inscope ::urn:VMEAccessServer ReadRegister $r.$RegName} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
       } else {
           InsertLog "ReadRegister $r.$RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc 0
       }
       return $rc
   }

   proc WriteRegister {RegName RegData} {
       global errorCode errorInfo
       variable ModuleName
       variable ModuleIndex
       variable allmodules
       variable Wmsg

       if {$allmodules == 0} then {set r $ModuleName#$ModuleIndex} else {set r $ModuleName#*}
       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegisters $r.$RegName $RegData} Wmsg]

       if {$z == 0} {
#           InsertLog "WriteRegister $r.$RegName returned: [lindex $Wmsg 5]"
       } else {
           InsertLog "WriteRegister $r.$RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc show_variables {} {
        variable A16Base
        variable A24Base
        variable A32Base
        variable alladcs
        variable allmodules
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag "
             InsertLog "ModuleMenu=$ModuleMenu; ModuleIndex=$ModuleIndex; "
             InsertLog "alladcs=$alladcs; allmodules=$allmodules"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

    proc UpdateModule {} {
        variable online
        variable rtp
        for {set i 0} {$i < 32} {incr i} {variable Threshold$i}

        set rtp [ReadRegister RTP]
        set online [ReadRegister Disable]

        for {set i 0} {$i < 32} {incr i} {
            set Threshold$i [ReadRegister Threshold$i]
        }
   }

     proc do_SetThreshold {j vl} {
        variable alladcs

           for {set i 0} {$i < 32} {incr i 1} {
              if {$alladcs == 0 && $j != $i} {continue}

              do_Threshold $i $vl
           }
     }

     proc do_Threshold {i vl} {WriteRegister Threshold$i $vl}
     proc do_RTP {vl} {WriteRegister RTP $vl}
     proc do_Online {vl} {WriteRegister Disable $vl}

    proc do_Save {which} {
        variable ModuleName
        variable ModuleIndex

       set SAV $ModuleIndex

           set ModuleIndex $which
           InsertLog "Saving Settings for [set ModuleName]#[set ModuleIndex]"

           set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

           set ::[set Project]::DBNodeName [string tolower $ModuleName]#[set ModuleIndex]
           DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

           DBSetValue RTP  [ReadRegister RTP]
           DBSetValue Online  [ReadRegister Disable]
           for {set i 0} {$i < 32} {incr i} {
              DBSetValue Threshold$i   [ReadRegister Threshold$i]
           }

        set ModuleIndex $SAV
    }

    proc do_SaveAll {} {
        variable ModuleName
        variable ModuleMenu

        foreach module $ModuleMenu {do_Save $module}

        InsertLog "Settings for All [set ModuleName] modules updated in DB"

        Elog INFORMATION "Settings for All [set ModuleName] modules updated in DB"
    }


   proc do_Restore {which} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleMenu
        variable allmodules
        variable alladcs

        set SAV1 $ModuleIndex
        set SAV2 $allmodules
        set SAV3 $alladcs

        set allmodules 0
        set alladcs 0
        set ModuleIndex $which

        InsertLog "Restoring Settings for [set ModuleName]#[set ModuleIndex]"

           set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

           WriteRegister RTP [DBGetValue RTP]
           WriteRegister Disable  [DBGetValue Online]

           for {set i 0} {$i < 32} {incr i} {
              WriteRegister Threshold$i   [DBGetValue Threshold$i]
           }

        set ModuleIndex $SAV1

        set allmodules $SAV2
        set alladcs $SAV3

    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
        variable ModuleIndex

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   alladcs    {variable alladcs; set alladcs [expr ($alladcs + 1) & 1]}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   OFFSET  {
                       set i [lindex $w 1]
                       if {$i < 32} {UpdateModule; do_SetThreshold $i [lindex $w 2]}
                       if {$i == 32} {do_RTP [lindex $w 2]}
                   }

                   ONLINE {do_Online [lindex $w 1]}

                   SAVEALL      {do_SaveAll}
                   RESTALL      {do_RestoreAll}
                   SAVE      {UpdateModule; do_Save $ModuleIndex}
                   RESTORE   {do_Restore $ModuleIndex}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}

