

#    TDC Readout  -   3x opcodes

#    30    enable TDC header and EOB in readout
#    31    disable TDC header and EOB in readout
#    32    read status
#    33    set max hits per event
#    34    read max hits per event
#    35    enable TDC error mark
#    36    disable TDC error mark
#    37    enable bypass TDC if error
#    38    disable bypass TDC if error
#    3b    set size of readout FIFO
#    3c    read size 

#    3X0   set control register bit 0
#    3X3   set control register bit 3


     proc do_rdoutopt {p  vl} {

# InsertLog "do_rdoutopt $p $vl"


#    p = 1;    enable TDC header and EOB in readout
#        2;    disable TDC header and EOB in readout
#        3;    enable TDC error mark
#        4;    disable TDC error mark
#        5;    enable bypass TDC if error
#        6;    disable bypass TDC if error

#       10;    set max hits per event
#       11;    set size of readout FIFO

          switch $p {
              1 {set opcode 0x3000}
              2 {set opcode 0x3100}
              3 {set opcode 0x3500}
              4 {set opcode 0x3600}
              5 {set opcode 0x3700}
              6 {set opcode 0x3800}
             10 {set opcode 0x3300}
             11 {set opcode 0x3b00}
          }

         if {$p == 10} {
     
          switch $vl {
             0  {set vl 0}
             1  {set vl 1}
             2  {set vl 2}
             4  {set vl 3}
             8  {set vl 4}
             16 {set vl 5}
             32 {set vl 6}
             64 {set vl 7}
             128 {set vl 8}
             default {set vl 9}
          }

          }

         if {$p == 11} {
     
          switch $vl {
             2  {set vl 0}
             4  {set vl 1}
             8  {set vl 2}
             16 {set vl 3}
             32 {set vl 4}
             64 {set vl 5}
             128 {set vl 6}
             256 {set vl 7}
          }

          }

          switch $p {
              10 {variable RdOutOpt10; set RdOutOpt10 $vl; set opcode 0x3300}
              11 {variable RdOutOpt11; set RdOutOpt11 $vl; set opcode 0x3b00}
              default {variable RdOutOpt$p; set RdOutOpt$p [expr ([set RdOutOpt$p] + 1) & 1]}
          }

          do_set_opcode $opcode $vl

# InsertLog "do_set_opcode $opcode $vl"

          redisplay_rdout
     }

     proc redisplay_rdout {} {
         variable RdOutOpt1
         variable RdOutOpt2
         variable RdOutOpt10
         variable RdOutOpt11

         set vl [do_read_opcode 0x3200]
         if {[expr $vl & 1] == 0} {set RdOutOpt1 0; set RdOutOpt2 1} else {set RdOutOpt1 1; set RdOutOpt2 0}

         set vl [do_read_opcode 0x3400]

# InsertLog "do_rdoutopt 0x3400 $vl [expr $vl]"

          switch [expr $vl] {
             0  {set vl 0}
             1  {set vl 1}
             2  {set vl 2}
             3  {set vl 4}
             4  {set vl 8}
             5  {set vl 16}
             6  {set vl 32}
             7  {set vl 64}
             8  {set vl 128}
             default {set vl "no limit"}
          }

         set RdOutOpt10 $vl

         set vl [do_read_opcode 0x3c00]

# InsertLog "do_rdoutopt 0x3c00 $vl [expr $vl]"

          switch [expr $vl] {
             0  {set vl 2}
             1  {set vl 4}
             2  {set vl 8}
             3  {set vl 16}
             4  {set vl 32}
             5  {set vl 64}
             6  {set vl 128}
             7  {set vl 256}
          }

         set RdOutOpt11 $vl

     }






