

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
    UpdateModule
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable allmodules 0
    variable allchannels 0
    variable allhvchannels 0

    variable ModuleName dt5780
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

    variable SoftTrigRun 0
    variable AcqPaused 0

    variable NumChans 2
    variable FamilyCode -1
    variable Name DT5780

   set z [catch {ReadRegister BoardInfo} BoardInfo]
   if {$z == 0 && [string range $BoardInfo 6 end] != "dead"} {
       set FamilyCode [expr $BoardInfo & 0xff]
       set NumChans [expr ($BoardInfo >> 16) & 0xff]
       if {$FamilyCode == 0} {set Name V1724PHA}
       if {$FamilyCode != 0} {set Name DT5780; set NumChans 2}
set Name DT5780; set NumChans 2
   }

#    for the Register Menus each item is a list
#      0) name for menu
#      1) register
#      2) file containing support implementation
#      3) Display procedure  (null if none)
#      4) parameter update procedure   (null if none)
#      5) parameter save procedure (null if none)
#      6) parameter restore procedure (null if none)

    variable ModuleRegMenu { \
       {"Configuration (0x8000)"             Config        Config.tml        GetConfig DrawConfig null null} \
       {"Buffer Organisation (0x800c)"       BufferOrg     BuffOrg.tml       GetBuffOrg DrawBuffOrg null null} \
       {"Acquisition Window(0x8020)"         CustomSize    CustSize.tml      GetCustSize DrawCustSize null null} \
       {"Start/Stop Run Delay (0x8170)"      RunDelay      RunDelay.tml      GetRunDelay DrawRunDelay null null} \
       {"Channel Enable Mask (0x8120)"       Enable        ChEnable.tml      GetChEnable DrawChEnable null null} \
       {"Trigger Source Enable (0x810c)"  TrigSrcEnable TrigSrcEnable.tml GetTrigSrcEnable DrawTrigSrcEnable null null} \
       {"FP Trigger Out Enable (0x8100)" FPTrigOutEnable  FPTrigEnable.tml  GetFPTrigEnable DrawFPTrigEnable null null} \
       {"FP I/O Control (0x811c)"             FPIOControl   FPIOCtrl.tml      GetFPIO DrawFPIO null null} \
       {"Acquisition Control (0x8100)"        AcqControl    AcqCtrl.tml       GetAcqCtrl DrawAcqCtrl null null} \
       {"Acquisition Status (0x8104)"         AcqStatus     AcqStatus.tml     GetAcqStatus DrawAcqStatus null null} \
       {"VME Control (0xef00)"                VMECtrl       VMECtrl.tml       GetVMECtrl DrawVMECtrl null null} \
       {"VME Status (0xef04)"                 VMEStatus     VMEStatus.tml     GetVMEStatus DrawVMEStatus null null} \
       {"System Options"                      SystemOpts    SystemOpts.tml    GetSystemOpts DrawSystemOpts null null} \
    }

    variable ChRegMenu { \
       {"Algorithm Control (0x1n80)"   AlgorithmControl AlgorithmControl.tml GetAlgorithmControl DrawAlgorithmControl \
                                    SaveAlgorithmControl RestAlgorithmControl} \
       {"BaseLine Hold Off (0x1n7c)"    BaseLineHoldOff BaseLineHoldOff.tml GetBaseLineHoldOff DrawBaseLineHoldOff \
                               SaveBaseLineHoldOff RestBaseLineHoldOff} \
       {"DC Offset (0x1n98)"   DCOffset  DCOffset.tml GetDCOffset DrawDCOffset SaveDCOffset RestDCOffset} \
       {"Decay Time (0x1n68)"       DecayTime DecayTime.tml GetDecayTime DrawDecayTime SaveDecayTime RestDecayTime} \
       {"Input Rise Time (0x1n58)"  InputRiseTime InputRiseTime.tml GetInputRiseTime DrawInputRiseTime \
                           SaveInputRiseTime RestInputRiseTime} \
       {"Peak Hold Off (0x1n78)"    PeakHoldOff PeakHoldOff.tml GetPeakHoldOff DrawPeakHoldOff \
                           SavePeakHoldOff RestPeakHoldOff} \
       {"Peaking Time (0x1n64)"     PeakingTime PeakingTime.tml GetPeakingTime DrawPeakingTime \
                           SavePeakingTime RestPeakingTime} \
       {"Pre Trigger Window (0x1n38)"    PreTrig  PreTrig.tml   GetPreTrig DrawPreTrig SavePreTrig RestPreTrig} \
       {"RTD Window Width (0x1n70)" RTDWinWidth RTDWinWidth.tml GetRTDWinWidth DrawRTDWinWidth \
                           SaveRTDWinWidth RestRTDWinWidth} \
       {"Trapezoid Flat Top (0x1n60)"   TrapFlatTop TrapFlatTop.tml GetTrapFlatTop DrawTrapFlatTop \
                               SaveTrapFlatTop RestTrapFlatTop} \
       {"Trapezoid Rise Time (0x1n5c)"  TrapRiseTime TrapRiseTime.tml GetTrapRiseTime DrawTrapRiseTime \
                               SaveTrapRiseTime RestTrapRiseTime} \
       {"Trigger and Timing Filter Smoothing (0x1n54)"  AvWindow AveragingWindow.tml GetAvWindow DrawAvWindow \
                           SaveAvWindow RestAvWindow} \
       {"Trigger Hold Off (0x1n74)" TrigHoldOff TrigHoldOff.tml GetTrigHoldOff DrawTrigHoldOff \
                           SaveTrigHoldOff RestTrigHoldOff} \
       {"Trigger Threshold (0x1n6c)"     Threshold TrigThreshold.tml GetThreshold DrawThreshold \
                                SaveThreshold RestThreshold} \
       {"Trigger Request Width (0x1n84)"   TrigWidth TrigWidth.tml GetTrigWidth DrawTrigWidth SaveTrigWidth RestTrigWidth} \
       {"Trig Val Mask (0x81nm)"   TrigValMask  TrigValMask.tml GetTrigValMask DrawTrigValMask SaveTrigValMask RestTrigValMask} \
    }

    variable HVRegMenu { \
       {"HV VSET"    HV_VSET    HVVSET.tml    GetHVVSET DrawHVVSET SaveHVVSET RestHVVSET} \
       {"HV VMAX"    HV_VMAX    HVVMAX.tml    GetHVVMAX DrawHVVMAX SaveHVVMAX RestHVVMAX} \
       {"HV VMON"    HV_VMON    HVVMON.tml    GetHVVMON DrawHVVMON SaveHVVMON RestHVVMON} \
       {"HV ISET"    HV_ISET    HVISET.tml    GetHVISET DrawHVISET SaveHVISET RestHVISET} \
       {"HV IMON"    HV_IMON    HVIMON.tml    GetHVIMON DrawHVIMON SaveHVIMON RestHVIMON} \
       {"HV RAMPUP"  HV_RAMPUP  HVRAMPUP.tml  GetHVRAMPUP DrawHVRAMPUP SaveHVRAMPUP RestHVRAMPUP} \
       {"HV RAMPDN"  HV_RAMPDN  HVRAMPDN.tml  GetHVRAMPDN DrawHVRAMPDN SaveHVRAMPDN RestHVRAMPDN} \
       {"HV Power"   HV_POWER   HVPOWER.tml   GetHVPOWER  DrawHVPOWER SaveHVPOWER RestHVPOWER} \
       {"HV Status"  HV_STATUS  HVSTATUS.tml  GetHVSTATUS DrawHVSTATUS null null} \
    }

#   registers for Save/Restore not handled by above (module registers)
    variable SaveRestoreMenu {Enable Config BufferOrg TrigSrcEnable FPTrigOutEnable FPIOControl \
                 AcqControl CustomSize RecLen  BLTEventNum}


    variable ModuleRegItem [lindex $ModuleRegMenu 0]
    variable ModuleReg [lindex $ModuleRegItem 0]

    variable ChRegItem [lindex $ChRegMenu 0]
    variable ChReg [lindex $ChRegItem 0]

    variable HVRegItem [lindex $HVRegMenu 0]
    variable HVReg [lindex $HVRegItem 0]


#    source all implementation files to load implementation code
  foreach item $ModuleRegMenu  {
     source [file join DT5780 [lindex $item 2]]
     set updateproc [lindex $item 3]
     if {$updateproc != "null"} {eval $updateproc}
  }

  foreach item $ChRegMenu  {
     source [file join DT5780 [lindex $item 2]]
     set updateproc [lindex $item 3]
     if {$updateproc != "null"} {eval $updateproc}
  }

  foreach item $HVRegMenu  {
     source [file join DT5780 [lindex $item 2]]
     set updateproc [lindex $item 3]
     if {$updateproc != "null"} {eval $updateproc}
  }

   proc do_RegisterHelp {W} {
      variable [set W]RegItem

       set f [lindex [set [set W]RegItem] 2]

        set Txtfile [file join DT5780 [file rootname $f].txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Unable to access $Txtfile\nInformation coming very soon!!\nFor now read the manual!!"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc do_ExpertHelp {} {

        set Txtfile [file join DT5780 Expert.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Unable to access $Txtfile\nInformation coming very soon!!\nFor now read the manual!!"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc show_variables {} {
        variable ModuleIndex
        variable ModuleName
        variable allchannels
        variable allmodules
        variable LogFlag
        variable DebugFlag
        variable ShowLogFlag
        variable ModuleRegItem
        variable ChRegItem
        variable Rmsg
        variable Wmsg
        variable SoftTrigRun

             InsertLog "ModuleName=$ModuleName; ModuleIndex=$ModuleIndex"
             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag; DebugFlag=$DebugFlag"
             InsertLog "allchannels=$allchannels; allmodules=$allmodules"
             InsertLog "ModuleReg=$ModuleRegItem"
             InsertLog "ChannelReg=$ChRegItem"
             InsertLog "SoftTrigRun=$SoftTrigRun"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
#           InsertLog "HasBeenConfigured = [::VMEConfig::ReadRegister HasBeenConfigured]"
#           InsertLog "HasBeenRestored = [::VMEConfig::ReadRegister HasBeenRestored]"

     variable NumChans
     variable Name
     InsertLog "ModName = $Name; NumChans = $NumChans"
   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

   proc UpdateModule {} {

       do_UpdateModuleRegisters
       do_UpdateChannelRegisters
       do_UpdateHVRegisters
   }

   proc UpdateChannel {} {

       do_UpdateChannelRegisters
   }

   proc do_UpdateModuleRegisters {} {
        variable ModuleRegMenu

        foreach item $ModuleRegMenu  {
            set updateproc [lindex $item 3]
            if {$updateproc != "null"} {eval $updateproc}
        }
   }

   proc do_UpdateChannelRegisters {} {
       variable ChRegMenu
       foreach item $ChRegMenu  {
           set updateproc [lindex $item 3]
           if {$updateproc != "null"} {eval $updateproc}
       }
   }

   proc do_UpdateHVRegisters {} {
       variable HVRegMenu
       foreach item $HVRegMenu  {
           set updateproc [lindex $item 3]
           if {$updateproc != "null"} {eval $updateproc}
       }
   }

   proc do_SelectModuleRegister {w} {
        variable ModuleReg
        variable ModuleRegItem
        variable ModuleRegMenu

      foreach item $ModuleRegMenu  {
         set name [lindex $item 0]
         if {"$w" == "$name"} {
             set ModuleRegItem $item
             set ModuleReg [lindex $item 1]
         }
      }
   }

   proc do_SelectChannelRegister {w} {
        variable ChReg
        variable ChRegItem
        variable ChRegMenu

      foreach item $ChRegMenu  {
         set name [lindex $item 0]
         if {"$w" == "$name"} {
             set ChRegItem $item
             set ChReg [lindex $item 1]
         }
      }
   }

   proc do_SelectHVRegister {w} {
        variable HVReg
        variable HVRegItem
        variable HVRegMenu

      foreach item $HVRegMenu  {
         set name [lindex $item 0]
         if {"$w" == "$name"} {
             set HVRegItem $item
             set HVReg [lindex $item 1]
         }
      }
   }

    proc do_SetModuleRegister {w v} {
        variable DebugFlag
        variable $w

        if {$DebugFlag == 1} {InsertLog "do_SetModuleRegister: $w = $v"}

        switch -glob $w {
            Config.*        {set $w $v; SetConfig}
            BuffOrg         {set $w $v; SetBuffOrg}
            ChEnableMask*   {set $w $v; SetChEnable}
            FPTrigEnable*   {set $w $v; SetFPTrigEnable}
            TrigSrcEnable*  {set $w $v; SetTrigSrcEnable}
            FPIO*           {set $w $v; SetFPIO}
            CustSize        {set $w $v; SetCustSize}
            RecLen          {set $w $v; SetRecLen}
            PostTrig        {set $w $v; SetPostTrig}
            RunDelay        {set $w $v; SetRunDelay}

            ReConfig        {WriteRegister ConfigReload 0; after 1000}
            Reset           {WriteRegister Reset 0; after 1000}

            AcqControl  -
            Clear -
            FlushEvBlk -
            SoftwareSyncReset -
            EvtsPerBuf -
            BLTEventNum -
            BufferOrg -
            SoftTrig        {WriteRegister $w $v}

            AcqCtrl*        {set $w $v; SetAcqCtrl}
            AcqStatus*      {}
            VMECtrl*        {set $w $v; SetVMECtrl}
            VMEStatus*      {}

            default {set $w $v}
        }
   }

    proc do_SetChannelRegister {w i vl} {
        variable allchannels
        variable DebugFlag
        variable NumChans

        if {$DebugFlag == 1} {InsertLog "do_SetChannelRegister:  $w $i = $vl"}

        for {set j 0} {$j < $NumChans} {incr j} {
           if {$allchannels == 0 && $j != $i} {continue}
           variable Ch$j.$w; set Ch$j.$w $vl
        }

        switch -glob $w {
            TrigValMask* {
                for {set j 0} {$j < $NumChans} {incr j} {
                    if {$allchannels == 0 && $j != $i} {continue}
                    SetTrigValMask $j
#variable Ch$j.TrigValMask
#InsertLog "SetTrigValMask Ch$j [format %08x [set Ch$j.TrigValMask]]"
                }
            }
            AlgorithmControl* {
                for {set j 0} {$j < $NumChans} {incr j} {
                    if {$allchannels == 0 && $j != $i} {continue}
                    SetAlgorithmControl $j
#variable Ch$j.AlgorithmControl
#InsertLog "SetAlgorithmControl Ch$j [format %08x [set Ch$j.AlgorithmControl]]"
                }
            }
            ExtTriggerMode -
            TrapReScale -
            BaseLineAvWin -
            Decimation -
            PeakAvWin -
            DigitalGain -
            InvertInput   {
                for {set j 0} {$j < $NumChans} {incr j} {
                    if {$allchannels == 0 && $j != $i} {continue}
                    WriteRegister Ch$j.$w $vl
                }
            }
            TrigWidth -
            PreTrig {
                for {set j 0} {$j < $NumChans} {incr j} {
                    if {$allchannels == 0 && $j != $i} {continue}
                    Set$w $vl
                }
            }
            default {if {$allchannels == 0} {WriteRegister Ch$i.$w $vl} else {WriteRegister $w $vl}}
       }
   }

   proc do_SoftTrig {n} {

      switch $n {
        1     {WriteRegister SoftTrig 1}
        0     {puts "DT5780 finished SoftTrig run"; set ::DT5780::SoftTrigRun 0}
        100   {set ::DT5780::SoftTrigRun 1; after 100 ::DT5780::do_SoftTrig 99}
        99999 {puts "DT5780 starting SoftTrig run"; set ::DT5780::SoftTrigRun 1; after 100 ::DT5780::do_SoftTrig 99998}
        99998 {if {$::DT5780::SoftTrigRun ==0} return; do_WriteSoftTrig; after 100 ::DT5780::do_SoftTrig 99998}
        default  {if {$::DT5780::SoftTrigRun ==0} return; do_WriteSoftTrig; if {$n > 0} {after 100 ::DT5780::do_SoftTrig [expr $n-1]}}
      }
   }

   proc do_WriteSoftTrig {} {
      global errorCode errorInfo
      variable Wmsg

       set r [set ::DT5780::ModuleName]#[set ::DT5780::ModuleIndex].SoftTrig
       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegister $r 1} Wmsg]
       if {$z != 0} {
           InsertLog "WriteRegister $r failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

    proc do_SetHVRegister {w i vl} {
        variable HVReg
        variable NumChans
        variable allhvchannels
        variable DebugFlag

        if {$DebugFlag == 1} {InsertLog "do_SetHVRegister:  $w $i = $vl   $HVReg"}

        for {set j 0} {$j < $NumChans} {incr j} {
           if {$allhvchannels == 0 && $j != $i} {continue}
           variable Ch$j.$w; set Ch$j.$w $vl
        }

#        set w $HVReg

        switch -glob $w {
            HVPOWER* {
                for {set j 0} {$j < $NumChans} {incr j} {
                    if {$allhvchannels == 0 && $j != $i} {continue}
                    variable Ch$j.$w; set Ch$j.$w $vl
                    SetHVPOWER $j
                }
            }
            HV* {
                for {set j 0} {$j < $NumChans} {incr j} {
                    if {$allhvchannels == 0 && $j != $i} {continue}
                    Set$w $j
                }
            }
            default {InsertLog "Unexpected setting in SetHVRegister: $w  $i  $vl"}
       }
   }

    proc do_Save {which} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleRegMenu
        variable ChRegMenu
        variable HVRegMenu
        variable SaveRestoreMenu
        variable Name

        set SAV $ModuleIndex

           set ModuleIndex $which
           InsertLog "Saving Settings for CAEN [set ModuleName]#[set ModuleIndex]"

           set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

           set ::[set Project]::DBNodeName [string tolower $ModuleName]#[set ModuleIndex]
           DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

           InsertLog "to  $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]"

           foreach item $ModuleRegMenu  {
               set saveproc [lindex $item 5]
               if {$saveproc != "null"} {eval $saveproc}
           }

           foreach item $ChRegMenu  {
               set saveproc [lindex $item 5]
               if {$saveproc != "null"} {eval $saveproc}
           }

           foreach item $HVRegMenu  {
               set hvproc [lindex $item 5]
               if {$hvproc != "null"} {eval $hvproc}
           }

           foreach item $SaveRestoreMenu {

               DBSetValue $item  [ReadRegister $item]
           }
 

        set ModuleIndex $SAV
    }

    proc do_SaveAll {} {
        variable ModuleName
        variable ModuleMenu

        foreach module $ModuleMenu {do_Save $module}

        InsertLog "Settings for All CAEN [set ModuleName] modules updated in DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules updated in DB"
    }

    proc do_Restore {which} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleMenu
        variable ModuleRegMenu
        variable ChRegMenu
        variable HVRegMenu
        variable SaveRestoreMenu
        variable allmodules
        variable allchannels
        variable Name

        set SAV1 $ModuleIndex
        set SAV2 $allmodules
        set SAV3 $allchannels

        set allmodules 0
        set allchannels 0

        set ModuleIndex $which
        InsertLog "Restoring Settings for CAEN [set ModuleName]#[set ModuleIndex]"

          set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

           set ::[set Project]::DBNodeName [string tolower $ModuleName]#[set ModuleIndex]

           DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

           InsertLog "from  $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]"

#        WriteRegister Reset 0   ;# software reset modules

           foreach item $ModuleRegMenu  {
               set restproc [lindex $item 6]
               if {$restproc != "null"} {eval $restproc}
           }

           foreach item $ChRegMenu  {
               set restproc [lindex $item 6]
               if {$restproc != "null"} {eval $restproc}
           }

               foreach item $HVRegMenu  {
                   set hvproc [lindex $item 5]
                   if {$hvproc != "null"} {eval $hvproc}
               }

           foreach item $SaveRestoreMenu {

               WriteRegister $item [DBGetValue $item]
           }

        set ModuleIndex $SAV1

        set allmodules $SAV2
        set allchannels $SAV3

    }

    proc do_RestoreAll {} {
        variable ModuleName
        variable ModuleMenu

       foreach module $ModuleMenu {do_Restore $module}

        ::VMEConfig::WriteRegister HasBeenRestored 1

        InsertLog "Settings for All CAEN [set ModuleName] modules restored from DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules restored from DB"
    }

    proc ReadDataFIFO {} {

        set datafifo [ReadRegister Output_Buffer]
        InsertLog "read data fifo returned: rc = [first $datafifo]; count=[second $datafifo]"

    }

     proc Show_ROM {} {

        for {set i 0} {$i <= 0x4c} {incr i 4} {
           InsertLog "$i; 0xF0[format %02X $i]; 0x[format %02x [ReadRegister ConfigROM[format %02x $i]]]"
        }

        for {set i 0x80} {$i <= 0x88} {incr i 4} {
           InsertLog "[expr $i]; 0xF0[format %02X $i]; 0x[format %02x [ReadRegister ConfigROM[format %02x $i]]]"
        }
     }


    proc do_Correlation {} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleMenu
        variable allmodules
        variable allchannels
        variable NumChans

        set SAV1 $ModuleIndex

        foreach ModuleIndex $ModuleMenu  {

        InsertLog "Performing coincidence setup check module $ModuleIndex "

#    ITRG  bit 2 in CONFIG register

        set reg [ReadRegister Config]
        set vl  [expr ($reg >> 2) & 1]

        if {$vl == 1} {
             InsertLog "CONFIG register bit EN_ITRG has the value 1 (ITRG enabled)"
        } else {
             WriteRegister Config [expr $reg | 0x00000004]
             InsertLog "CONFIG register bit EN_ITRG has been set to 1"
        }

#    Coincidence enable

        for {set i 0} {$i < [set NumChans]} {incr i} {
           set reg [ReadRegister Ch$i.DPP_MISC]
           set vl [expr ($reg >> 18) & 3]

           if {$vl == 2} {
               InsertLog "Ch$i DPP_MISC register TRG_MODE (bits 19:18) has the value 2 (coincidence enabled)"
           } else {
               WriteRegister Ch$i.DPP_MISC [expr ($reg & 0xfff3fff) | 0x00080000]
               InsertLog "Ch$i DPP_MISC register TRG_MODE (bits 19:18) has been set to 2"
           }
        }

#    trigger request width

        for {set i 0} {$i < [set NumChans]} {incr i} {
           set reg [ReadRegister Ch$i.TrigWidth]
           set vl [expr $reg * 8]

           if {$vl > 0} {
               InsertLog "Ch$i Trig Request Width register has the value $vl ns"
           } else {
               WriteRegister Ch$i.TrigWidth 1
               InsertLog "Ch$i Trig Request Width register has been set to 8ns"
           }
        }

#    coincidence mask register 

        InsertLog "Trigger Validation Mask register"

        for {set i 0} {$i < [set NumChans]} {incr i} {
           set reg [ReadRegister Ch$i.TrigValMask]
           set vl $reg

           switch $vl {
              0x20000000    {InsertLog "Ch$i PowerUp default; LVDS+Channel"}
              0x40000000    {InsertLog "Ch$i EXT TRG + Channel"}
              0x80000000    {InsertLog "Ch$i SOFT TRG + Channel"}
              default       {InsertLog "Ch$i Trig Val Mask register has the value $vl"}
           }
        }

        }

        set ModuleIndex $SAV1

    }

    proc do_AcqPause {} {
        variable AcqPaused 

        if {$AcqPaused == 1} {return}

        WriteRegister AcqControl 0

        set AcqPaused 1

    }

    proc do_AcqResume {} {
        variable AcqPaused 

        if {$AcqPaused == 0} {return}

        WriteRegister AcqControl 4

        set AcqPaused 0
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag
       variable ModuleIndex

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {UpdateModule}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}

                   ALLCHANS   {variable allchannels; set allchannels [expr ($allchannels + 1) & 1]}
                   ALLHVCHANS {variable allhvchannels; set allhvchannels [expr ($allhvchannels + 1) & 1]}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   MREGISTER      {do_SelectModuleRegister [string range $w 10 end]}
                   MREGISTERHELP  {do_RegisterHelp Module}

                   EXPERT {
                      switch [lindex $w 1] {
                        Help      {do_ExpertHelp}
                        FirmwareUpdate {Alert "Start firmware update from VME Control page"}
                        SoftTrig  {do_SoftTrig [lindex $w 2]}
                        Reset -
                        Clear -
                        SoftwareSyncReset -
                        FlushEvBlk -
                        ReConfig  {do_SetModuleRegister [lindex $w 1] 0}
                        AcqStart  {source [file join DT5780 AcqStart.tcl]}
                        AcqHalt   {source [file join DT5780 AcqHalt.tcl]}
                        DataFIFO    {ReadDataFIFO}
                        Scratch     {WriteRegister Scratch 12345}
                        ROM       {Show_ROM}
                        default   {}
                      }
                   }
                   EXPERTHELP    {do_ExpertHelp}

                   CHREGISTER      {do_SelectChannelRegister [string range $w 11 end]}
                   CHREGISTERHELP  {do_RegisterHelp Ch}

                   HVREGISTER      {do_SelectHVRegister [string range $w 11 end]}
                   HVREGISTERHELP  {do_RegisterHelp HV}

                   MSETTING      {do_SetModuleRegister [lindex $w 1] [lindex $w 2]}
                   MSETTINGS     {do_SetModuleRegister [lindex $cgidata 4] [lindex $cgidata 5]}
 
                   CHSETTING     {do_SetChannelRegister [lindex $w 1] [lindex $w 2] [lindex $w 3]}
                   HVSETTING    {do_SetHVRegister [lindex $w 1] [expr [lindex $w 2]-4] [lindex $w 3]}

                   PLLWRITEFLASH {PLLWriteFlash}
                   PLLREADFLASH  {PLLReadFlash}
                   PLLUPDATEFLASH {PLLUpdateFlash}
                   PLLRELOADFLASH {PLLReloadFlash}

                   PLLCLKENABLE {
                       switch [lindex $w 1] {
                           false {variable ClockDelayEnable; set ClockDelayEnable 0}
                           true  {variable ClockDelayEnable; set ClockDelayEnable 1}
                       }
                       PLLUpdateFlash
                   }

                   PLLOUTENABLE {
                       switch [lindex $w 1] {
                           false {variable OutputClockEnable; set OutputClockEnable 0}
                           true  {variable OutputClockEnable; set OutputClockEnable 1}
                       }
                       PLLUpdateFlash
                   }

                   PLLCLKDELAY   {variable ClockDelay; set ClockDelay [lindex $w 1]; PLLUpdateFlash}
                   
                   SAVEALL      {do_SaveAll}
                   RESTALL      {do_RestoreAll}
                   SAVE         {do_Save $ModuleIndex}
                   RESTORE      {do_Restore $ModuleIndex}

                   CORRELATION  {do_Correlation}
                   PAUSE        {do_AcqPause}
                   RESUME       {do_AcqResume}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}


     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

