
#    V1730 with standard firmware

    set A32Base [third [split $AddressData :]]

    variable NumChans 16
    variable Name V1730

   DefineRegister $Module xVME BoardInfo           "-a $A32Base -w 32 -o 0x8140 -p ro -d 32 -l 0 -b 0 -z x"

   set BoardInfo [ReadVMERegister $Module.BoardInfo]
   if {[string range $BoardInfo 6 end] != "dead"} {
       set FamilyCode [expr $BoardInfo & 0xff]
       set NumChans [expr ($BoardInfo >> 16) & 0xff]
   }

   DefineRegister $Module xVME ConfigReload        "-a $A32Base -w 32 -o 0xef34 -p wo -d 32"
   DefineRegister $Module xVME Clear               "-a $A32Base -w 32 -o 0xef28 -p wo -d 32"
   DefineRegister $Module xVME Reset               "-a $A32Base -w 32 -o 0xef24 -p wo -d 32"
   DefineRegister $Module xVME Scratch             "-a $A32Base -w 32 -o 0xef20 -p rw -d 32 -l 0 -b 0 -z x"

   DefineRegister $Module xVME BLTEventNum         "-a $A32Base -w 32 -o 0xef1c -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME VMEBaseAddress      "-a $A32Base -w 32 -o 0xef10 -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME MCSTBaseAddress     "-a $A32Base -w 32 -o 0xef0c -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME BoardID             "-a $A32Base -w 32 -o 0xef08 -p ro -d 32 -l 5 -b 0 -z x"
   DefineRegister $Module xVME VMEStatus           "-a $A32Base -w 32 -o 0xef04 -p ro -d 32 -l 4 -b 0 -z x"
   DefineRegister $Module xVME VMEControl          "-a $A32Base -w 32 -o 0xef00 -p rw -d 32 -l 0 -b 0 -z d"

   DefineRegister $Module xVME ADCSync             "-a $A32Base -w 32 -o 0x813c -p wo -d 32"
   DefineRegister $Module xVME MemFullLevel        "-a $A32Base -w 32 -o 0x816c -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME RunDelay            "-a $A32Base -w 32 -o 0x8170 -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME FPLVDSIO            "-a $A32Base -w 32 -o 0x81a0 -p rw -d 32 -l 0 -b 0 -z x"

   DefineRegister $Module xVME EventSize           "-a $A32Base -w 32 -o 0x814c -p ro -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME MonitorMode         "-a $A32Base -w 32 -o 0x8144 -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME MonitorDAC          "-a $A32Base -w 32 -o 0x8138 -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME EventsStored        "-a $A32Base -w 32 -o 0x812c -p ro -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME FPGARev             "-a $A32Base -w 32 -o 0x8124 -p ro -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME Enable              "-a $A32Base -w 32 -o 0x8120 -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME PostTrig            "-a $A32Base -w 32 -o 0x8114 -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME FPIOControl         "-a $A32Base -w 32 -o 0x811c -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME FPIOData            "-a $A32Base -w 32 -o 0x8118 -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME FPTrigEnable        "-a $A32Base -w 32 -o 0x8110 -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME TrigSrcEnable       "-a $A32Base -w 32 -o 0x810c -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME SoftTrig            "-a $A32Base -w 32 -o 0x8108 -p wo -d 32"
   DefineRegister $Module xVME AcqStatus           "-a $A32Base -w 32 -o 0x8104 -p ro -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME AcqControl          "-a $A32Base -w 32 -o 0x8100 -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME CustomSize          "-a $A32Base -w 32 -o 0x8020 -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME RecLen              "-a $A32Base -w 32 -o 0x8020 -p rw -d 32 -l 0 -b 0 -z d"

   DefineRegister $Module xVME BufferOrg           "-a $A32Base -w 32 -o 0x800c -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME ConfigClr           "-a $A32Base -w 32 -o 0x8008 -p wo -d 32"
   DefineRegister $Module xVME ConfigSet           "-a $A32Base -w 32 -o 0x8004 -p wo -d 32"
   DefineRegister $Module xVME Config              "-a $A32Base -w 32 -o 0x8000 -p rw -d 32 -l 0 -b 0 -z x"

   DefineRegister $Module xVME DAC          "-a $A32Base -w 32 -o 0x8098 -p wo -d 32"
   DefineRegister $Module xVME Threshold    "-a $A32Base -w 32 -o 0x8080 -p wo -d 32"
   DefineRegister $Module xVME Dummy32      "-a $A32Base -w 32 -o 0x8024 -p wo -d 32"
   DefineRegister $Module xVME DynRnge      "-a $A32Base -w 32 -o 0x8028 -p wo -d 32"
   DefineRegister $Module xVME PulseWidth   "-a $A32Base -w 32 -o 0x8070 -p wo -d 32"
   DefineRegister $Module xVME ADCCal       "-a $A32Base -w 32 -o 0x809c -p wo -d 32"

   for {set ijk 0} {$ijk < $NumChans} {incr ijk} {
      DefineRegister $Module xVME Ch$ijk.RecLen     "-a $A32Base -w 32 -o [expr 0x1020+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z d"
      DefineRegister $Module xVME Ch$ijk.DAC        "-a $A32Base -w 32 -o [expr 0x1098+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME Ch$ijk.FPGARev    "-a $A32Base -w 32 -o [expr 0x108c+($ijk*0x100)] -p ro -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME Ch$ijk.Status     "-a $A32Base -w 32 -o [expr 0x1088+($ijk*0x100)] -p ro -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME Ch$ijk.TempMon    "-a $A32Base -w 32 -o [expr 0x10a8+($ijk*0x100)] -p ro -d 32 -l 0 -b 0 -z d"
      DefineRegister $Module xVME Ch$ijk.Threshold  "-a $A32Base -w 32 -o [expr 0x1080+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z d"
      DefineRegister $Module xVME Ch$ijk.Dummy32    "-a $A32Base -w 32 -o [expr 0x1024+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME Ch$ijk.DynRnge    "-a $A32Base -w 32 -o [expr 0x1028+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z d"
      DefineRegister $Module xVME Ch$ijk.PulseWidth "-a $A32Base -w 32 -o [expr 0x1070+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z d"
   }

   set Ch 0
   for {set ijk 0} {$ijk < $NumChans} {incr ijk 2} {
          DefineRegister $Module xVME Ch$Ch.SelfTrig   "-a $A32Base -w 32 -o [expr 0x1084+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z d"
          incr Ch
          DefineRegister $Module xVME Ch$Ch.SelfTrig   "-a $A32Base -w 32 -o [expr 0x1084+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z d"
          incr Ch
   }

   for {set ijk 0} {$ijk <= 0x50} {incr ijk 4} {
      DefineRegister $Module xVME ConfigROM[format %02x $ijk] "-a $A32Base -w 32 -o 0xf0[format %02x $ijk] -p r0 -d 32 -l 0 -b 0 -z x"
   }
   for {set ijk 0x80} {$ijk <= 0x84} {incr ijk 4} {
      DefineRegister $Module xVME ConfigROM[format %02x $ijk] "-a $A32Base -w 32 -o 0xf0[format %02x $ijk] -p r0 -d 32 -l 0 -b 0 -z x"
   }

   DefineRegister $Module xVME DataItem            "-a $A32Base -w 32 -o 0x0 -p ro -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module bVME Output_Buffer       "-a $A32Base -w 32 -o 0x0 -p ro -d 32 -z x -l 1024"

puts "Defined $Module"
