

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable offline 0
    variable overflow 0
    variable zero 0
    variable alladcs 0
    variable allmodules 0
    variable slide 0
    variable step 0
    variable fastclear 40

    variable eventcounter 0

    variable OperationMode 0
    for {set i 0} {$i < 32} {incr i} {variable Enable$i 1}
    for {set i 0} {$i < 32} {incr i} {variable Threshold$i $i}

    variable Rmsg
    variable Wmsg

    variable ModuleName v785
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}


   proc show_variables {} {
        variable ModuleIndex
        variable ModuleMenu
        variable alladcs
        variable allmodules
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
             InsertLog "ModuleMenu=$ModuleMenu; ModuleIndex=$ModuleIndex"
             InsertLog "alladcs=$alladcs; allmodules=$allmodules"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

    proc UpdateModule {} {
        variable offline
        variable overflow
        variable zero
        variable slide
        variable step
        variable fastclear
        variable eventcounter

        set ECLow  [ReadRegister EvCounter_Low]
        set ECHigh [ReadRegister EvCounter_High]

        set eventcounter [expr ($ECHigh << 16) + $ECLow]

        variable OperationMode
        for {set i 0} {$i < 32} {incr i} {variable Enable$i}
        for {set i 0} {$i < 32} {incr i} {variable Threshold$i}

        set fastclear [ReadRegister Fast_Clear_Window]

            set vl [ReadRegister Bit_Set_2]
            set OperationMode $vl
            set offline [expr ($vl >> 1) & 1]
            set overflow [expr ($vl >> 3) & 1]
            set zero [expr ($vl >> 4) & 1]
            set slide [expr ($vl >> 7) & 1]
            set step [expr ($vl >> 8) & 1]
 
        for {set i 0} {$i < 32} {incr i} {
            set Threshold$i [ReadRegister Threshold$i]
            set Enable$i [ReadRegister Disable$i]
        }
   }

    proc do_SetOperationMode {w v} {

       switch $w {
           OFFLINE   {set data 0x02}
           OVERFLOW  {set data 0x08}
           ZERO      {set data 0x10}
           SLIDE     {set data 0x80}
           STEP      {set data 0x100}
       }

       switch $v {
          1   {WriteRegister Bit_Set_2 $data}
          0   {WriteRegister Bit_Clear_2 $data}
       }
 
    }

    proc do_OperationMode {v} {
       WriteRegister Bit_Clear_2 0xffff
       WriteRegister Bit_Set_2 $v
    }

     proc do_SetThreshold {j vl} {
        variable alladcs

           for {set i 0} {$i < 32} {incr i 1} {
              if {$alladcs == 0 && $j != $i} {continue}

              do_Threshold $i $vl
           }
     }

     proc do_Threshold {i vl} {WriteRegister Threshold$i $vl}

     proc do_FastClear {vl} {WriteRegister Fast_Clear_Window $vl}

     proc do_SetEnable {j vl} {
        variable alladcs

        if {$vl == "true"} {set Vl 0} else {set Vl 1}

          for {set i 0} {$i < 32} {incr i 1} {
             if {$alladcs == 0 && $j != $i} {continue}

             do_Enable $i $Vl
          }
     }

    proc do_Enable {i vl} {WriteRegister Disable$i $vl}

    proc do_Save {which} {
        variable ModuleName
        variable ModuleIndex

       set SAV $ModuleIndex

           set ModuleIndex $which
           InsertLog "Saving Settings for CAEN [set ModuleName]#[set ModuleIndex]"

           set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

           set ::[set Project]::DBNodeName [string tolower $ModuleName]#[set ModuleIndex]
           DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

           DBSetValue OperationMode  [ReadRegister Bit_Set_2]
           DBSetValue FastClear      [ReadRegister Fast_Clear_Window]
           for {set i 0} {$i < 32} {incr i} {
              DBSetValue Threshold$i   [ReadRegister Threshold$i]
              DBSetValue Disable$i      [ReadRegister Disable$i]
           }

        set ModuleIndex $SAV
    }

    proc do_SaveAll {} {
        variable ModuleName
        variable ModuleMenu

        foreach module $ModuleMenu {do_Save $module}

        InsertLog "Settings for All CAEN [set ModuleName] modules updated in DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules updated in DB"
    }

   proc do_Restore {which} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleMenu
        variable allmodules
        variable alladcs

        set SAV1 $ModuleIndex
        set SAV2 $allmodules
        set SAV3 $alladcs

        set allmodules 0
        set alladcs 0
        set ModuleIndex $which

        InsertLog "Restoring Settings for CAEN [set ModuleName]#[set ModuleIndex]"

           set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

          WriteRegister Bit_Set_1 0x80; WriteRegister Bit_Clear_1 0x80   ;# reset module

           do_OperationMode [DBGetValue OperationMode]
           do_FastClear     [DBGetValue FastClear]

           for {set i 0} {$i < 32} {incr i} {
              WriteRegister Threshold$i   [DBGetValue Threshold$i]
              WriteRegister Disable$i      [DBGetValue Disable$i]
           }

        set ModuleIndex $SAV1

        set allmodules $SAV2
        set alladcs $SAV3

    }

    proc do_RestoreAll {} {
        variable ModuleName
        variable ModuleMenu

       foreach module $ModuleMenu {do_Restore $module}

        ::VMEConfig::WriteRegister HasBeenRestored 1

        InsertLog "Settings for All CAEN [set ModuleName] modules restored from DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules restored from DB"
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable ModuleIndex

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ALLADCS    {variable alladcs; set alladcs [expr ($alladcs + 1) & 1]}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   OFFSET  {
                       set i [lindex $w 1]
                       if {$i < 32} {UpdateModule; do_SetThreshold $i [lindex $w 2]}
                       if {$i == 32} {do_FastClear [lindex $w 2]}
                   }

                   ENABLE  {UpdateModule; do_SetEnable [lindex $w 1] [lindex $w 2]}

                   OFFLINE   {do_SetOperationMode OFFLINE [lindex $w 1]}
                   OVERFLOW  {do_SetOperationMode OVERFLOW [lindex $w 1]}
                   SLIDE     {do_SetOperationMode SLIDE [lindex $w 1]}
                   ZERO      {do_SetOperationMode ZERO [lindex $w 1]}
                   STEP      {do_SetOperationMode STEP [lindex $w 1]}

                   SOFTRESET {WriteRegister Bit_Set_1 0x80; WriteRegister Bit_Clear_1 0x80}

                   SAVEALL      {do_SaveAll}
                   RESTALL      {do_RestoreAll}
                   SAVE         {do_Save $ModuleIndex}
                   RESTORE      {do_Restore $ModuleIndex}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}

