

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable ModuleName v812
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex -1

    variable numchans 16

    variable allmodules 0
    variable allchans 0

    for {set i 0} {$i < $numchans} {incr i} {variable Enable$i 0}
    for {set i 0} {$i < $numchans} {incr i} {variable Threshold$i 0}

    variable width0 0
    variable width1 0
    variable dtime0 0
    variable dtime1 0
    variable mthresh 0

    variable SaveRestoreMenu {OutputWidthL OutputWidthH DeadTimeL DeadTimeH MajorityThreshold}
    for {set i 0} {$i < $numchans} {incr i} {lappend SaveRestoreMenu Enable$i}
    for {set i 0} {$i < $numchans} {incr i} {lappend SaveRestoreMenu Threshold$i}

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

#    register access procedures


    proc WriteRegister {RegName RegData} {
       global errorCode errorInfo
       variable ModuleName
       variable ModuleIndex
       variable Wmsg
       variable allmodules
      

       if {$allmodules == 0} then {set r $ModuleName#$ModuleIndex} else {set r $ModuleName#*}
       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegisters $r.$RegName $RegData} Wmsg]

       if {$z == 0} {
            set rc 0
           InsertLog "WriteVMERegisters $r.$RegName $RegData [format 0x%x $RegData]"
       } else {
           set rc -1
           InsertLog "WriteVMERegisters failed: $r.$RegName; Data=$RegData; Code= $errorCode; Info= [first [split $errorInfo \n]]"
#           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
       return $rc
    }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         if {$i == $ModuleIndex} {return}

         do_Save
         set ModuleIndex $i
         do_Restore
   }

   proc show_variables {} {
        variable ModuleName
        variable ModuleIndex
        variable ModuleMenu
        variable allmodules
        variable allchans
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

        variable width0 
        variable width1 
        variable dtime0 
        variable dtime1 
        variable mthresh
        variable numchans
        for {set i 0} {$i < $numchans} {incr i} {variable Threshold$i}
        for {set i 0} {$i < $numchans} {incr i} {variable Enable$i}


        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "ModuleMenu=$ModuleMenu; ModuleName=$ModuleName; ModuleIndex=$ModuleIndex; "
        InsertLog "allmodules=$allmodules; allchans=$allchans"
        InsertLog "Rmsg=$Rmsg"
        InsertLog "Wmsg=$Wmsg"

        InsertLog "width0=$width0; width1=$width1; dtime0=$dtime0; dtime1=$dtime1; mthresh=$mthresh;"
        for {set i 0} {$i < $numchans} {incr i} {InsertLog "Threshold$i=[set Threshold$i];"}
        for {set i 0} {$i < $numchans} {incr i} {InsertLog "Enable$i=[set Enable$i];"}
   }


    proc click-doModuleSettings {} {
        variable ModuleMenu
        variable ModuleIndex
        variable allmodules
        variable width0 
        variable width1 
        variable dtime0 
        variable dtime1 
        variable mthresh
        variable numchans
        for {set i 0} {$i < $numchans} {incr i} {variable Threshold$i}
        for {set i 0} {$i < $numchans} {incr i} {variable Enable$i}

        set SAV $ModuleIndex
        set SAV1 $allmodules

        foreach item $ModuleMenu {

            if {$allmodules == 0 && $item != $ModuleIndex} {continue}

            do_Select  $item

            set allmodules 0

            WriteRegister OutputWidthL $width0
            WriteRegister OutputWidthH $width1
            WriteRegister DeadTimeL $dtime0
            WriteRegister DeadTimeH $dtime1
            WriteRegister MajorityThreshold [expr ((($mthresh*50)-25)+2)/4]

            for {set i 0} {$i < $numchans} {incr i} {WriteRegister Threshold$i [set Threshold$i]}

            set Dat 0
            for {set i 0} {$i < $numchans} {incr i} {
              set Dat [expr $Dat |  ([set Enable$i] << $i)]
            }
  
            WriteRegister Enable $Dat

            set allmodules $SAV1

        }

        do_Select $SAV
    }

    proc click-OFFSET {w vl} {
        variable ModuleMenu
        variable ModuleIndex
        variable allmodules

        set SAV $ModuleIndex

        foreach item $ModuleMenu {

            if {$allmodules == 0 && $item != $ModuleIndex} {continue}

            do_Select  $item

            do-OFFSET $w $vl
        }

        do_Select $SAV

    }

    proc click-ENABLE {w vl} {
        variable ModuleMenu
        variable ModuleIndex
        variable allmodules

        set SAV $ModuleIndex

        foreach item $ModuleMenu {

            if {$allmodules == 0 && $item != $ModuleIndex} {continue}

            do_Select  $item

            do-ENABLE $w $vl
        }

        do_Select $SAV

    }

    proc do-OFFSET {w vl} {
        variable allchans
        variable width0 
        variable width1 
        variable dtime0 
        variable dtime1 
        variable mthresh
        variable numchans
        for {set i 0} {$i < $numchans} {incr i} {variable Threshold$i}

#InsertLog "do-OFFSET $w $vl"

       switch $w {

           16   {set width0 $vl}
           17   {set width1 $vl}
           18   {set dtime0 $vl}
           19   {set dtime1 $vl}
           20   {set mthresh $vl}

           default   {
                 set Threshold$w $vl
                 for {set i 0} {$i < $numchans} {incr i} {
                    if {$allchans == 1} {set Threshold$i $vl}
                 }
           }

       }
    }

    proc do-ENABLE {w vl} {
        variable allchans
        variable numchans
        for {set i 0} {$i < $numchans} {incr i} {variable Enable$i}

#InsertLog "click-ENABLE $w $vl"

          if {$w == 16} {
              switch $vl {
                 false  {set Enable 0}
                 true   {set Enable 1}
              }
              for {set i 0} {$i < $numchans} {incr i} {set Enable$i $Enable}
              return
          }

          for {set i 0} {$i < $numchans} {incr i} {
             if {$allchans == 0 && $w != $i} {continue}
                 switch $vl {
                   false  {set Enable$i 0}
                   true   {set Enable$i 1}
                 }
          }
    }

    proc do_Save {} {
        variable ModuleIndex
        variable ModuleName
        variable width0 
        variable width1 
        variable dtime0 
        variable dtime1 
        variable mthresh
        variable numchans
        for {set i 0} {$i < $numchans} {incr i} {variable Threshold$i}
        for {set i 0} {$i < $numchans} {incr i} {variable Enable$i}

#           InsertLog "Saving Settings for CAEN [set ModuleName]#[set ModuleIndex]"

           set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

           set ::[set Project]::DBNodeName [string tolower $ModuleName]#[set ModuleIndex]
           DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

           DBSetValue OutputWidthL $width0
           DBSetValue OutputWidthH $width1
           DBSetValue DeadTimeL $dtime0
           DBSetValue DeadTimeH $dtime1
           DBSetValue MajorityThreshold $mthresh

           for {set i 0} {$i < $numchans} {incr i} {DBSetValue Threshold$i [set Threshold$i]}
           for {set i 0} {$i < $numchans} {incr i} {DBSetValue Enable$i [set Enable$i]}

    }

    proc do_Restore {} {
        variable ModuleIndex
        variable ModuleName
        variable width0 
        variable width1 
        variable dtime0 
        variable dtime1 
        variable mthresh
        variable numchans
        for {set i 0} {$i < $numchans} {incr i} {variable Threshold$i}
        for {set i 0} {$i < $numchans} {incr i} {variable Enable$i}

 
#        InsertLog "Restoring Settings for CAEN [set ModuleName]#[set ModuleIndex]"

           set Project $::DataAcquisition::PROJECT
           set DBRootName [set ::[set Project]::DBRootName]
           set DBNodeBase [set ::[set Project]::DBNodeBase]

           set ::[set Project]::DBNodeName [string tolower $ModuleName]#[set ModuleIndex]
           DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

           set width0 [DBGetValue OutputWidthL]
           set width1 [DBGetValue OutputWidthH]
           set dtime0 [DBGetValue DeadTimeL]
           set dtime1 [DBGetValue DeadTimeH]
           set mthresh [DBGetValue MajorityThreshold]

           for {set i 0} {$i < $numchans} {incr i} {set Threshold$i [DBGetValue Threshold$i]}
           for {set i 0} {$i < $numchans} {incr i} {set Enable$i [DBGetValue Enable$i]}

    }


     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}

                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}
                   ALLCHANS   {variable allchans; set allchans [expr ($allchans + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   ENABLE   {click-ENABLE [lindex $w 1] [lindex $w 2]}
                   OFFSET   {click-OFFSET [lindex $w 1] [lindex $w 2]}

                   SAVE     {do_Save}
                   RESTORE  {do_Restore}

                   UPDATE     {click-doModuleSettings}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
       }
    }

    do_Select 1

}   ;# end of if {$started == 0}

