

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

     do_DBUpdate
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable DBNameList ""
    variable DBName ""

   variable index 0
   variable selected 0

   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable selected
        variable DBName

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "selected=$selected"
        InsertLog "DBName=$DBName"

        InsertLog "HasBeenConfigured = [ReadVMERegister HasBeenConfigured]"
        InsertLog "HasBeenRestored = [ReadVMERegister HasBeenRestored]"

        set Project $::DataAcquisition::PROJECT
        set DBRootName [set ::[set Project]::DBRootName]
        set DBNodeBase [set ::[set Project]::DBNodeBase]
        set DBNodeName [set ::[set Project]::DBNodeName]

        InsertLog "DBRootName = $DBRootName"
        InsertLog "DBNodeBase = $DBNodeBase"
        InsertLog "DBNodeName = $DBNodeName"

        set ::[set Project]::DBNodeName "undefined"
   }

      proc Selection {} {
          variable selected

          set selected 0

          if {![info exists ::VMEConfig::NumModules]} return

           for {set i 1} {$i <= $::VMEConfig::NumModules} {incr i} {
               if {[set ::VMEConfig::ModuleType($i)] != ""} {set selected [expr $selected | (1 << $i)]}
           }
      }

      proc do_Select {i} {
         variable selected

         set selected [expr $selected | (1 << $i)]
      }

      proc do_UnSelect {i} {
         variable selected

         set selected [expr $selected & ~(1 << $i)]
      }

      proc __save {m i} {

          set Project $::DataAcquisition::PROJECT
          set DBRootName [set ::[set Project]::DBRootName]
          set DBNodeBase [set ::[set Project]::DBNodeBase]
          set ::[set Project]::DBNodeName [string tolower $m]#[set i]

          DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]
          set z [catch {::[set m]::do_Save $i} msg]
          if {$z != 0} {InsertLog "save for $m failed $msg"}
      }

      proc __restore {m i} {

          set Project $::DataAcquisition::PROJECT
          set DBRootName [set ::[set Project]::DBRootName]
          set DBNodeBase [set ::[set Project]::DBNodeBase]
          set ::[set Project]::DBNodeName [string tolower $m]#[set i]

          DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]
          set z [catch {::[set m]::do_Restore $i} msg]
          if {$z != 0} {InsertLog "restore for $m failed $msg"}
      }

      proc do_Save {} {
        variable JS
        variable selected
        variable ::VMEConfig::Module_Name
        variable ::VMEConfig::ModuleType
        variable ::VMEConfig::NumModules

    if {![info exists ::VMEConfig::started] || [ReadVMERegister HasBeenConfigured] == 0} {
          set html "<script>alert(\"No hardware configuration selected and activated\\nDo this first\");</script>"
          return
    }

         if {$selected == 0} {Selection}

        set Project $::DataAcquisition::PROJECT
        set DBRootName [set ::[set Project]::DBRootName]
        set DBNodeBase [set ::[set Project]::DBNodeBase]
      
        EmptyLog
        InsertLog "Saving VME settings to $DBRootName/$DBNodeBase"
        
          for {set i 1} {$i <= $::VMEConfig::NumModules} {incr i} {
             if {[expr ($selected >> $i) & 1] == 0} {continue}
             set moduleindex [second [split [set ::VMEConfig::Module_Name($i)] #]]

             switch [set ::VMEConfig::ModuleType($i)] {
                 CAEN_V785     {__save V785 $moduleindex}
                 CAEN_V775     {__save V775 $moduleindex}
                 CAEN_V1190    {__save V1190 $moduleindex}
                 CAEN_V1290    {__save V1290 $moduleindex}
                 CAEN_V1724    {__save V1724 $moduleindex}
                 CAEN_V1724PHA {__save V1724PHA $moduleindex}
                 CAEN_DT5780   {__save DT5780 $moduleindex}
                 CAEN_V1725    {__save V1725 $moduleindex}
                 CAEN_V1725PSD {__save V1725PSD $moduleindex}
                 CAEN_V1725PHA {__save V1725PHA $moduleindex}
                 CAEN_V1720    {__save V1720 $moduleindex}
                 CAEN_V1730    {__save V1730 $moduleindex}
                 CAEN_V1730PSD {__save V1730PSD $moduleindex}
                 CAEN_V1730PHA {__save V1730PHA $moduleindex}
                 CAEN_V1740    {__save V1740 $moduleindex}
                 CAEN_V1742    {__save V1742 $moduleindex}
                 CAEN_V1751    {__save V1751 $moduleindex}
                 CAEN_V1751PSD {__save V1751PSD $moduleindex}
                 CAEN_V1495    {__save V1495 $moduleindex}
                 CAEN_V1495DPP {__save V1495DPP $moduleindex}
                 CAEN_V560     {__save V560 $moduleindex}
                 CAEN_V830     {__save V830 $moduleindex}
                 MyRIAD        {__save MyRIAD $moduleindex}
                 PatternGen    {__save PatternGen $moduleindex}
                 SAC           {}
                 default {InsertLog "no SAVE defined for [set ::VMEConfig::ModuleType($i)]" }
             }
             InsertLog "VME settings saved for [set ::VMEConfig::Module_Name($i)]"
          }

        InsertLog "VME settings saved to [set DBRootName]/[set DBNodeBase]"

        set m $JS

        Elog INFORMATION "VME settings saved to [set DBRootName]/[set DBNodeBase]"

        do_DBUpdate

         return $m
    }

      proc do_Restore {} {
        variable JS
        variable selected
        variable ::VMEConfig::Module_Name
        variable ::VMEConfig::ModuleType
        variable ::VMEConfig::NumModules

    if {![info exists ::VMEConfig::started] || [ReadVMERegister HasBeenConfigured] == 0} {
          set html "<script>alert(\"No hardware configuration selected and activated\\nDo this first\");</script>"
          return
    }

         if {$selected == 0} {Selection}

        set Project $::DataAcquisition::PROJECT
        set DBRootName [set ::[set Project]::DBRootName]
        set DBNodeBase [set ::[set Project]::DBNodeBase]

        EmptyLog
        InsertLog "Restoring VME settings from $DBRootName/$DBNodeBase"
        
          for {set i 1} {$i <= $::VMEConfig::NumModules} {incr i} {
             if {[expr ($selected >> $i) & 1] == 0} {continue}
             set moduleindex [second [split [set ::VMEConfig::Module_Name($i)] #]]

             switch [set ::VMEConfig::ModuleType($i)] {
                 CAEN_V785     {__restore V785 $moduleindex}
                 CAEN_V775     {__restore V775 $moduleindex}
                 CAEN_V1190    {__restore V1190 $moduleindex}
                 CAEN_V1290    {__restore V1290 $moduleindex}
                 CAEN_V1724    {__restore V1724 $moduleindex}
                 CAEN_V1724PHA {__restore V1724PHA $moduleindex}
                 CAEN_DT5780   {__restore DT5780 $moduleindex}
                 CAEN_V1725    {__restore V1725 $moduleindex}
                 CAEN_V1725PSD {__restore V1725PSD $moduleindex}
                 CAEN_V1725PHA {__restore V1725PHA $moduleindex}
                 CAEN_V1720    {__restore V1720 $moduleindex}
                 CAEN_V1730    {__restore V1730 $moduleindex}
                 CAEN_V1730PSD {__restore V1730PSD $moduleindex}
                 CAEN_V1730PHA {__restore V1730PHA $moduleindex}
                 CAEN_V1740    {__restore V1740 $moduleindex}
                 CAEN_V1742    {__restore V1742 $moduleindex}
                 CAEN_V1751    {__restore V1751 $moduleindex}
                 CAEN_V1751PSD {__restore V1751PSD $moduleindex}
                 CAEN_V1495    {__restore V1495 $moduleindex}
                 CAEN_V1495DPP {__restore V1495DPP $moduleindex}
                 CAEN_V560     {__restore V560 $moduleindex}
                 CAEN_V830     {__restore V830 $moduleindex}
                 MyRIAD        {__restore MyRIAD $moduleindex}
                 PatternGen    {__restore PatternGen $moduleindex}
                 SAC           {}
                 default {InsertLog "no RESTORE defined for [set ::VMEConfig::ModuleType($i)]"}
             }
             InsertLog "VME settings restored for [set ::VMEConfig::Module_Name($i)]"
          }

        InsertLog "VME settings restored from $DBRootName/$DBNodeBase"

         set m $JS

        WriteVMERegister HasBeenRestored 1

        Elog INFORMATION "VME settings restored from $DBRootName/$DBNodeBase"

        do_DBUpdate

       return $m
    }

      proc do_DBName {vl} {
         global Options
         variable DBName
 
        set Project $::DataAcquisition::PROJECT
        set DBRootName [set ::[set Project]::DBRootName]
        set DBNodeBase [set ::[set Project]::DBNodeBase]

          if {$vl != "undefined"} {set DBNodeBase $vl}
          DBCreateNode $DBRootName/$DBNodeBase

          set Options(VME.settings) $DBNodeBase

          set ::[set Project]::DBNodeBase $vl
          set DBName $vl

          ::OPTION::SaveOptions

          InsertLog "Data Base node $DBRootName/$DBNodeBase contains [DBGetNodes $DBRootName/$DBNodeBase *]"
      }

      proc do_DBUpdate {} {
        variable DBNameList

        set Project $::DataAcquisition::PROJECT
        set DBRootName [set ::[set Project]::DBRootName]
        set DBNodeBase [set ::[set Project]::DBNodeBase]

          set DBNameList {}
          foreach item [DBGetNodes $DBRootName *] {
              if {$item == "Options"} continue
              lappend DBNameList $item
          }
      }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {variable selected; if {$selected == 0} {Selection}}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                DBNAMES -
                DBNAME   {do_DBName [lindex $w 1]}

                GENKEY   {do_DBName [date +%Y%h%d-%H.%M.%S]}

                RESTORE  {do_Restore}
                SAVE     {do_Save}
      
                SELECT    {do_Select [lindex $w 1]}
                UNSELECT  {do_UnSelect [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }   ;#  end of do_click

     Selection

     global Options
     do_DBName $Options(VME.settings)

     do_DBUpdate

}  ;# end of if {$started == 0}

