#  maxv.defn.tcl

#    split up address information into 
   set addressinfo [split $AddressData :]
   set A16Base [first $addressinfo]

   DefineRegister $Module MAXv X.Command.WriteOnly	"-a $A16Base -x X -p wo -n 0"
   DefineRegister $Module MAXv X.Command.WriteRead	"-a $A16Base -x X -p rw -n 1"
   DefineRegister $Module MAXv Y.Command.WriteOnly	"-a $A16Base -x Y -p wo -n 0"
   DefineRegister $Module MAXv Y.Command.WriteRead	"-a $A16Base -x Y -p rw -n 1"
   DefineRegister $Module MAXv Z.Command.WriteOnly	"-a $A16Base -x Z -p wo -n 0"
   DefineRegister $Module MAXv Z.Command.WriteRead	"-a $A16Base -x Z -p rw -n 1"
   DefineRegister $Module MAXv T.Command.WriteOnly	"-a $A16Base -x T -p wo -n 0"
   DefineRegister $Module MAXv T.Command.WriteRead	"-a $A16Base -x T -p rw -n 1"
   DefineRegister $Module MAXv U.Command.WriteOnly	"-a $A16Base -x U -p wo -n 0"
   DefineRegister $Module MAXv U.Command.WriteRead	"-a $A16Base -x U -p rw -n 1"
   DefineRegister $Module MAXv V.Command.WriteOnly	"-a $A16Base -x V -p wo -n 0"
   DefineRegister $Module MAXv V.Command.WriteRead	"-a $A16Base -x V -p rw -n 1"

   DefineRegister $Module xVME CommandMailbox       	"-a $A16Base -o 0x4c -w 16 -d 32  -p ro"


puts "Defined $Module"

proc {XXX OMS MAXv6000_DAQ-reset} {args} {
#   MAXv
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[write-vme-register $module.X.Command.WriteRead "WY;"] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}


proc {OMS MAXv6000_DAQ-reset} {args} {
# The above crashes the stepper program.
# Do nothing for now, while we investigate. scl 25/08/09
}

proc {OMS MAXv6000_DAQ-flush} {args} {
#   MAXv
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {OMS MAXv6000_DAQ-go} {args} {
#   MAXv
    global CurrentVMEServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {OMS MAXv6000_DAQ-halt} {args} {
#   MAXv
    global CurrentVMEServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {OMS MAXv6000_DAQ-setup} {args} {
#   MAXv
    global CurrentVMEServer RegisterServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

#   for parameter save/restore
set {OMS MAXv6000_registersavepatterns} {}
