#  xvme240.defn.tcl

#    split up address information into 
   set addressinfo [split $AddressData :]
   set A16Base [first $addressinfo]


   DefineRegister Analyser aVME Energy		          "-a $A16Base -o 0x88 -w 16 -d16 - rw -qk -teV -n3 -r0:0eV,0xffff:416667eV -i 0eV"
   DefineRegister Analyser xVME Power		          "-a $A16Base -o 0x8a -w 16 -d 8 - rw -z d -b 0 -l 1 -i 0"
   DefineRegister Goniometer xVME Rota.Select	          "-a $A16Base -o 0x8a -w 16 -d 8 - ro -z d -b 1 -l 1 -i 0"
   DefineRegister Goniometer xVME Spin.Select	          "-a $A16Base -o 0x8a -w 16 -d 8 - ro -z d -b 2 -l 1 -i 0"
   DefineRegister Goniometer xVME Tilt.Select	          "-a $A16Base -o 0x8a -w 16 -d 8 - ro -z d -b 3 -l 1 -i 0"
#   DefineRegister Analyser xVME Angle.Select	         "-a $A16Base -o 0x00 -w 16 -d 8 - ro -z d -b 4 -l 1 -i 0"
   DefineRegister Integrator xVME Start		          "-a $A16Base -o 0x8a -w 16 -d 8 - rw -z d -b 5 -l 1 -i 1"
   DefineRegister Integrator xVME Stop		          "-a $A16Base -o 0x8a -w 16 -d 8 - rw -z d -b 6 -l 1 -i 1"
   DefineRegister Integrator xVME Load		          "-a $A16Base -o 0x8a -w 16 -d 8 - rw -z d -b 7 -l 1 -i 0"
   DefineRegister Integrator xVME Running		  "-a $A16Base -o 0x8b -w 16 -d 8 - ro -z d -b 0 -l 1"
   DefineRegister Integrator dosestep Dose.Step	          "-a[expr $A16Base+0x8b] -d 8 -b 1 -l 6"
   DefineRegister Integrator pps PPS		          "-a[expr $A16Base+0x8b] -d 8 -b 1 -l 2"
   DefineRegister Integrator fullscale Current.Range      "-a[expr $A16Base+0x8b] -d 8 -b 3 -l 4"
   DefineRegister Integrator xVME Range		          "-a $A16Base -o 0x8b -w 16 -d 8 - ro -z d -b 3 -l 4"
   DefineRegister Integrator percent Percent	          "-a[expr $A16Base+0x8c]"
   DefineRegister Integrator xVME Readout		  "-a $A16Base -o 0x8c -w 16 -d16 - ro -z x"
   DefineRegister Integrator xVME Preset		  "-a $A16Base -o 0x8e -w 16 -d16 - rw -z x -i 0"
   DefineRegister Integrator dose Dose		          "-a[expr $A16Base+0x88]"

   DefineRegister $Module xVME Port0			  "-a $A16Base -o 0x88 -w 16 -d 8 - rw -z x"
   DefineRegister $Module xVME Port1			  "-a $A16Base -o 0x89 -w 16 -d 8 - rw -z x"
   DefineRegister $Module xVME Port2	 		  "-a $A16Base -o 0x8a -w 16 -d 8 - rw -z x"
   DefineRegister $Module xVME Port3			  "-a $A16Base -o 0x8b -w 16 -d 8 - rw -z x"
   DefineRegister $Module xVME Port4			  "-a $A16Base -o 0x8c -w 16 -d 8 - rw -z x"
   DefineRegister $Module xVME Port5			  "-a $A16Base -o 0x8d -w 16 -d 8 - rw -z x"
   DefineRegister $Module xVME Port6			  "-a $A16Base -o 0x8e -w 16 -d 8 - rw -z x"
   DefineRegister $Module xVME Port7			  "-a $A16Base -o 0x8f -w 16 -d 8 - rw -z x"

   DefineRegister $Module xVME CSR			  "-a $A16Base -o 0x81 -w 16 -d 8 - rw -z x"
   DefineRegister $Module xVME Red			  "-a $A16Base -o 0x81 -w 16 -d 8 - rw -z d -b 0 -l 1"
   DefineRegister $Module xVME Green			  "-a $A16Base -o 0x81 -w 16 -d 8 - rw -z d -b 1 -l 1"
   DefineRegister $Module xVME Int.ORPend		  "-a $A16Base -o 0x81 -w 16 -d 8 - ro -z d -b 2 -l 1"
   DefineRegister $Module xVME Int.Enable		  "-a $A16Base -o 0x81 -w 16 -d 8 - rw -z d -b 3 -l 1"
   DefineRegister $Module xVME Reset			  "-a $A16Base -o 0x81 -w 16 -d 8 - rw -z d -b 4 -l 1"
   DefineRegister $Module xVME Int.Input		  "-a $A16Base -o 0x80 -w 16 -d 8 - ro -z x"
   DefineRegister $Module xVME Int.Pending		  "-a $A16Base -o 0x82 -w 16 -d 8 - ro -z x"
   DefineRegister $Module xVME Int.Mask		          "-a $A16Base -o 0x83 -w 16 -d 8 - rw -z x"
   DefineRegister $Module xVME Int.Clear		  "-a $A16Base -o 0x84 -w 16 -d 8 - rw -z x"
   DefineRegister $Module xVME Int.Vector		  "-a $A16Base -o 0x85 -w 16 -d 8 - rw -z d"
   DefineRegister $Module xVME Flag			  "-a $A16Base -o 0x86 -w 16 -d 8 - rw -z x"
   DefineRegister $Module xVME Direction		  "-a $A16Base -o 0x87 -w 16 -d 8 - rw -z x"
   DefineRegister $Module xVME Port0.Output		  "-a $A16Base -o 0x87 -w 16 -d 8 - rw -z d -b 0 -l 1"
   DefineRegister $Module xVME Port1.Output		  "-a $A16Base -o 0x87 -w 16 -d 8 - rw -z d -b 1 -l 1"
   DefineRegister $Module xVME Port2.Output		  "-a $A16Base -o 0x87 -w 16 -d 8 - rw -z d -b 2 -l 1"
   DefineRegister $Module xVME Port3.Output		  "-a $A16Base -o 0x87 -w 16 -d 8 - rw -z d -b 3 -l 1"
   DefineRegister $Module xVME Port4.Output		  "-a $A16Base -o 0x87 -w 16 -d 8 - rw -z d -b 4 -l 1"
   DefineRegister $Module xVME Port5.Output		  "-a $A16Base -o 0x87 -w 16 -d 8 - rw -z d -b 5 -l 1"
   DefineRegister $Module xVME Port6.Output		  "-a $A16Base -o 0x87 -w 16 -d 8 - rw -z d -b 6 -l 1"
   DefineRegister $Module xVME Port7.Output		  "-a $A16Base -o 0x87 -w 16 -d 8 - rw -z d -b 7 -l 1"

   DefineRegister $Module bVME ID			  "-a $A16Base -o 0x00 -w 16 -d 8 - ro -z c -l 48"


puts "Defined $Module"

proc {Xycom XVME240_DAQ-reset} {args} {
#   XVME240
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.CSR] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {Xycom XVME240_DAQ-flush} {args} {
#   XVME240
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Xycom XVME240_DAQ-go} {args} {
#   XVME240
    global CurrentVMEServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Xycom XVME240_DAQ-halt} {args} {
#   XVME240
    global CurrentVMEServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Xycom XVME240_DAQ-setup} {args} {
#   XVME240
    global CurrentVMEServer RegisterServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
    set RegisterServer $CurrentVMEServer
    write-vme-register $module.Reset 1
    write-vme-register $module.CSR 0
# Green LED on
    write-vme-register $module.Green 1
# Clear all interrupts
    write-vme-register $module.Int.Clear 0xff
# Pports 3,4,5 ip 0,1,2,6,7 op
    write-vme-register $module.Direction 0xc7

    set id [read-vme-register $module.ID]
    if {[Xycom_verify $id "VMEIDXYC240    1"]} then {
# Passed
# Red off (write 1)
       write-vme-register $module.Red 1
# Green off (write 1) Confusing eh?
       write-vme-register $module.Green 1
    } else {
# Failed
       write-vme-register $module.CSR 0
    }
}

#   for parameter save/restore
set {Xycom XVME240_registersavepatterns} {}

proc Xycom_verify {rid tid} {
#   XVME240
    for {set t 0; set r -2} {$t<[string length $tid]} {incr t} {
#        if {[string index $tid $t] != [lindex $rid [incr r 2]]} {return 0}
        if {[string index $tid $t] != [string index $rid [incr r 4]]} {return 0}
    }
    return 1;
}
