#  xvme560.defn.tcl


#    split up address information into 
   set addressinfo [split $AddressData :]
   set A16Base [first $addressinfo]


   DefineRegister Analyser xvme560 Volts+		"-a $A16Base -c1 -g1 -qk -uV -d2 -r0:0V,0xfff:25kV"
   DefineRegister Analyser xvme560 Volts-		"-a $A16Base -c2 -g1 -qk -uV -d2 -r0:0V,0xfff:25kV"
   DefineRegister Analyser xvme560 Current+	        "-a $A16Base -c3 -g1 -qu -uA -d0 -r0:0A,0xfff:1mA"
   DefineRegister Analyser xvme560 Current-	        "-a $A16Base -c4 -g1 -qu -uA -d0 -r0:0A,0xfff:1mA"
   DefineRegister Detector xvme560 Volts		"-a $A16Base -c5 -g0 -q  -uV -d0 -r0:0V,0xfff:3.5kV"
   DefineRegister Detector xvme560 Current		"-a $A16Base -c6 -g0 -qu -uA -d0 -r0:0A,0xfff:1mA"
#   DefineRegister Integrator xvme560 Current	"-a $A16Base -c7 -g0 -qu -uA -d0 -r0:0A,0xfff:1mA"
   DefineRegister Integrator xvme560 Current	        "-a $A16Base -c7 -g0"

   DefineRegister $Module xvme560 Zero		        "-a $A16Base -c1 -g1 -qm -uV -d0 -r0:0V,0xfff:10V"
   DefineRegister $Module xvme560 Channel0		"-a $A16Base -c1 -g1"
   DefineRegister $Module xvme560 Channel1		"-a $A16Base -c1 -g1"
   DefineRegister $Module xvme560 Channel2		"-a $A16Base -c2 -g1"
   DefineRegister $Module xvme560 Channel3		"-a $A16Base -c3 -g1"
   DefineRegister $Module xvme560 Channel4		"-a $A16Base -c4 -g1"
   DefineRegister $Module xvme560 Channel5		"-a $A16Base -c5 -g0"
   DefineRegister $Module xvme560 Channel6		"-a $A16Base -c6 -g0"
   DefineRegister $Module xvme560 Channel7		"-a $A16Base -c7 -g0"

   DefineRegister $Module xVME CSR			"-a $A16Base -o 0x81 -w 16 -d 8  -p rw -z x -b 0"
   DefineRegister $Module xVME Red			"-a $A16Base -o 0x81 -w 16 -d 8  -p rw -z d -b 0 -l 1"
   DefineRegister $Module xVME Green			"-a $A16Base -o 0x81 -w 16 -d 8  -p rw -z d -b 1 -l 1"
   DefineRegister $Module xVME Int.Pend		        "-a $A16Base -o 0x81 -w 16 -d 8  -p rw -z d -b 2 -l 1"
   DefineRegister $Module xVME Int.Enable		"-a $A16Base -o 0x81 -w 16 -d 8  -p rw -z d -b 3 -l 1"
   DefineRegister $Module xVME Reset			"-a $A16Base -o 0x81 -w 16 -d 8  -p rw -z d -b 4 -l 1"
   DefineRegister $Module xVME Mode			"-a $A16Base -o 0x81 -w 16 -d 8  -p rw -z d -b 5 -l 2"
   DefineRegister $Module xVME Convert		        "-a $A16Base -o 0x81 -w 16 -d 8  -p rw -z d -b 7 -l 1"
   DefineRegister $Module xVME Int.Vector		"-a $A16Base -o 0x83 -w 16 -d 8  -p rw -z d"
   DefineRegister $Module xVME Channel		        "-a $A16Base -o 0x85 -w 16 -d 8  -p rw -z d -b 0 -l 6"
   DefineRegister $Module xVME Gain			"-a $A16Base -o 0x85 -w 16 -d 8  -p rw -z d -b 6 -l 2"
   DefineRegister $Module xVME Data			"-a $A16Base -o 0x86 -w 16 -d 16 -p ro -z x -b 0 -l 12"

   DefineRegister $Module bVME ID			"-a $A16Base -o 0x00 -w 16 -d 8  -p ro -z c -l 48"


puts "Defined $Module"

proc {Xycom XVME560_DAQ-reset} {args} {
#   XVME560
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.CSR] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {Xycom XVME560_DAQ-flush} {args} {
#   XVME560
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Xycom XVME560_DAQ-go} {args} {
#   XVME560
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Xycom XVME560_DAQ-halt} {args} {
#   XVME560
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Xycom XVME560_DAQ-setup} {args} {
#   XVME560
    global CurrentVMEServer RegisterServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    set RegisterServer $CurrentVMEServer
    write-vme-register $module.Reset 1
    write-vme-register $module.CSR 0
# Green LED on
    write-vme-register $module.Green 1
# Random mode
    write-vme-register $module.Mode 2
    initialise-registers $module.*
    set id [read-vme-register $module.ID]
    if {[Xycom_verify $id "VMEIDXYC560    1"]} then {
# Passed
       write-vme-register $module.Green 1
       write-vme-register $module.Red 1
       write-vme-register $module.Mode 2
    } else {
# Failed
       write-vme-register $module.Green 0
       write-vme-register $module.Red 0
       write-vme-register $module.Mode 2
    }
}

#   for parameter save/restore
set {Xycom XVME560_registersavepatterns} {}

proc Xycom_verify {rid tid} {
#   XVME560
    for {set t 0; set r -2} {$t<[string length $tid]} {incr t} {
#        if {[string index $tid $t] != [lindex $rid [incr r 2]]} {return 0}
        if {[string index $tid $t] != [string index $rid [incr r 4]]} {return 0}
    }
    return 1;
}
